unit DLG_IB_Ordering;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls, 
  Buttons, ExtCtrls,

  IB_Components;

type
  TdlgOrdering = class(TForm)
    OKBtn: TButton;
    CancelBtn: TButton;
    lbOrdering: TListBox;
    Bevel1: TBevel;
    DataSource: TIB_DataSource;
    procedure lbOrderingDblClick(Sender: TObject);
    procedure DataSourceAfterAssignment(Sender: TIB_DataSource;
      ADataSet: TIB_DataSet);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  dlgOrdering: TdlgOrdering;

implementation

{$R *.DFM}

procedure TdlgOrdering.lbOrderingDblClick(Sender: TObject);
begin
  OkBtn.Click;
end;

procedure TdlgOrdering.DataSourceAfterAssignment(Sender: TIB_DataSource;
  ADataSet: TIB_DataSet);
begin
  if ADataSet <> nil then begin
    ADataSet.GetOrderingItemsList( lbOrdering.Items );
    lbOrdering.ItemIndex := Abs( ADataSet.OrderingItemNo ) - 1;
  end else begin
    lbOrdering.Items.Clear;
    lbOrdering.ItemIndex := 0;
  end;
end;

procedure TdlgOrdering.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  if ( ModalResult = mrOk ) and ( DataSource.DataSet <> nil ) then begin
    with DataSource.DataSet do begin
      if GetOrderingSQL( lbOrdering.ItemIndex + 1 ) = '' then begin
        OrderingItemNo := -(lbOrdering.ItemIndex + 1);
      end else begin
        if ( OrderingItemNo = lbOrdering.ItemIndex + 1 ) and
           ( GetOrderingSQL( -(lbOrdering.ItemIndex + 1)) <> '' ) then begin
          OrderingItemNo := -OrderingItemNo;
        end else begin
          OrderingItemNo := lbOrdering.ItemIndex + 1;
        end;
      end;
    end;
  end;
end;

end.


