unit
  FRM_IB_Browse;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Mask, Grids, ExtCtrls, ComCtrls, Registry,

  FRM_IB_Base,

  IB_TransactionBar,
  IB_StatementBar,
  IB_Controls,
  IB_CursorGrid,
  IB_StatementGrid,
  IB_SearchBar,
  IB_NavigationBar,
  IB_Components,
  IB_TransactionSource,
  IB_ConnectionSource,
  IB_Schema,
  IB_SearchPanel;

type
  TfrmBrowse = class(TfrmBase)
    pcBrowse: TPageControl;
    tsRelations: TTabSheet;
    Panel20: TPanel;
    Panel22: TPanel;
    IB_NavigationBar2: TIB_NavigationBar;
    rbTables: TRadioButton;
    rbViews: TRadioButton;
    cbSystem: TCheckBox;
    cbDomainInfo: TCheckBox;
    IB_SearchBar1: TIB_SearchBar;
    Panel18: TPanel;
    pcRelExtract: TPageControl;
    tsRelFields: TTabSheet;
    sgExtractFields: TIB_StatementGrid;
    tsData: TTabSheet;
    cgBrowse: TIB_CursorGrid;
    tsIndicies: TTabSheet;
    meIndicies: TMemo;
    tsConstraints: TTabSheet;
    meConstraints: TMemo;
    tsTriggers: TTabSheet;
    lbTriggers: TListBox;
    pnSizerTriggers: TPanel;
    Panel19: TPanel;
    meTriggers: TIB_Memo;
    Panel35: TPanel;
    Label10: TLabel;
    Label11: TLabel;
    Label13: TLabel;
    IB_Edit1: TIB_Edit;
    IB_Edit2: TIB_Edit;
    IB_Edit3: TIB_Edit;
    btEditTrigger: TButton;
    tsViewSource: TTabSheet;
    meViewSource: TIB_Memo;
    tsRelDesc: TTabSheet;
    meRelDesc: TIB_Memo;
    Panel36: TPanel;
    lbRelations: TListBox;
    pnSizerRelations: TPanel;
    TabSheet10: TTabSheet;
    lbProcedures: TListBox;
    pnSizerProcedures: TPanel;
    Panel24: TPanel;
    Panel21: TPanel;
    btEditProc: TButton;
    IB_StatementBar1: TIB_StatementBar;
    IB_TransactionBar4: TIB_TransactionBar;
    Panel33: TPanel;
    Panel34: TPanel;
    pcProcExtract: TPageControl;
    tsProcSource: TTabSheet;
    meProcudureSource: TIB_Memo;
    tsProcedureInputs: TTabSheet;
    IB_StatementGrid5: TIB_StatementGrid;
    tsProcedureOutputs: TTabSheet;
    IB_StatementGrid6: TIB_StatementGrid;
    tsProcDesc: TTabSheet;
    meProcDesc: TIB_Memo;
    tsDomains: TTabSheet;
    lbDomains: TListBox;
    pnSizerDomains: TPanel;
    tsGenerators: TTabSheet;
    lbGenerators: TListBox;
    pnSizerGenerators: TPanel;
    crRelations: TIB_Cursor;
    crTriggerExtract: TIB_Cursor;
    crProcExtract: TIB_Cursor;
    crProcParams: TIB_Cursor;
    dsProcExtract: TIB_DataSource;
    dsqlProcExtract: TIB_DSQL;
    crRelDesc: TIB_Cursor;
    dsRelDesc: TIB_DataSource;
    dsTriggerExtract: TIB_DataSource;
    dsRelations: TIB_DataSource;
    spBrowse: TIB_SearchPanel;
    procedure FormCreate(Sender: TObject);
    procedure IB_ConnectionSourceConnectedChanged(
      Sender: TIB_ConnectionLink; AConnection: TIB_Connection);
    procedure IB_ConnectionSourceAfterExecDDL(Sender: TIB_ConnectionLink;
      AConnection: TIB_Connection);
    procedure lbRelationsClick(Sender: TObject);
    procedure lbRelationsKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure cbDomainInfoClick(Sender: TObject);
    procedure lbTriggersClick(Sender: TObject);
    procedure lbProceduresClick(Sender: TObject);
    procedure lbProceduresKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure lbTriggersKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure btEditTriggerClick(Sender: TObject);
    procedure btEditProcClick(Sender: TObject);
    procedure pcRelExtractChange(Sender: TObject);
    procedure RelationsClick(Sender: TObject);
    procedure IB_TransactionSourceAfterAssignment(
      Sender: TIB_TransactionLink; ATransaction: TIB_Transaction);
    procedure IB_ConnectionSourceAfterAssignment(
      Sender: TIB_ConnectionLink; AConnection: TIB_Connection);
    procedure pnSizerRelationsMouseDown(Sender: TObject;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure pnSizerRelationsMouseMove(Sender: TObject;
      Shift: TShiftState; X, Y: Integer);
    procedure pnSizerRelationsMouseUp(Sender: TObject;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure FormDestroy(Sender: TObject);
    procedure dsRelationsStateChanged(Sender: TIB_DataSource;
      ADataSet: TIB_DataSet);
    procedure IB_SearchBar1AfterAction(Sender: TObject);
    procedure dsTriggerExtractStateChanged(Sender: TIB_DataSource;
      ADataSet: TIB_DataSet);
    procedure dsProcExtractStateChanged(Sender: TIB_DataSource;
      ADataSet: TIB_DataSet);
  private
    { Private declarations }
    PanelSizing: boolean;
  protected
    procedure DoReadSettings; override;
    procedure DoWriteSettings; override;
  public
    { Public declarations }
    procedure ReadInValues;
  end;

implementation

uses
  IB_Parse, FRM_IB_DSQL;
  
{$R *.DFM}

procedure TfrmBrowse.FormCreate(Sender: TObject);
begin
  inherited;
  SetDefaultBounds( 0, 0, 600, 400 );
  pcBrowse.ActivePage := tsRelations;
  pcRelExtract.ActivePage := tsRelFields;
  pcProcExtract.ActivePage := tsProcSource;
  cgBrowse.Align := alClient;
end;

procedure TfrmBrowse.DoReadSettings;
begin
  with RegDB do begin
    lbRelations.Width  := ReadInteger('Settings', 'lbRelations.Width',  120);
    lbTriggers.Width   := ReadInteger('Settings', 'lbTriggers.Width',   120);
    lbProcedures.Width := ReadInteger('Settings', 'lbProcedures.Width', 120);
    lbDomains.Width    := ReadInteger('Settings', 'lbDomains.Width',    120);
    lbGenerators.Width := ReadInteger('Settings', 'lbGenerators.Width', 120);
    with pcBrowse do begin
      ActivePage := Pages[ ReadInteger('Settings', 'Page Index', 0) ];
    end;
  end;
end;

procedure TfrmBrowse.DoWriteSettings;
begin
  with RegDB do begin
    WriteInteger( 'Settings','lbRelations.Width', lbRelations.Width);
    WriteInteger( 'Settings','lbTriggers.Width', lbTriggers.Width);
    WriteInteger( 'Settings','lbProcedures.Width', lbProcedures.Width);
    WriteInteger( 'Settings','lbDomains.Width', lbDomains.Width);
    WriteInteger( 'Settings','lbGenerators.Width', lbGenerators.Width);
    WriteInteger('Settings', 'Page Index', pcBrowse.ActivePage.PageIndex );
  end;
end;

procedure TfrmBrowse.IB_ConnectionSourceAfterAssignment(
  Sender: TIB_ConnectionLink; AConnection: TIB_Connection);
begin
  crRelations.IB_Connection := AConnection;
  crTriggerExtract.IB_Connection := AConnection;
  crProcExtract.IB_Connection := AConnection;
  dsqlProcExtract.IB_Connection := AConnection;
  crProcParams.IB_Connection := AConnection;
  crRelDesc.IB_Connection := AConnection;
end;

procedure TfrmBrowse.IB_TransactionSourceAfterAssignment(
  Sender: TIB_TransactionLink; ATransaction: TIB_Transaction);
begin
  crRelations.IB_Transaction := ATransaction;
  crTriggerExtract.IB_Transaction := ATransaction;
  crProcExtract.IB_Transaction := ATransaction;
  dsqlProcExtract.IB_Transaction := ATransaction;
  crProcParams.IB_Transaction := ATransaction;
  crRelDesc.IB_Transaction := ATransaction;
  IB_TransactionBar4.IB_Transaction := ATransaction;
end;

{------------------------------------------------------------------------------}

procedure TfrmBrowse.ReadInValues;
begin
  if IB_Connection <> nil then with IB_Connection do begin
    Screen.Cursor := crSQLWait;
    try
      Connected := true;
      RelationsClick( nil );
      lbProcedures.Items.Text := Info_ProcedureNames.Text;
      lbDomains.Items.Text    := Info_DomainNames.Text;
      lbGenerators.Items.Text := Info_GeneratorNames.Text;
      if Connected then begin
        crTriggerExtract.Prepared := true;
        crProcExtract.Prepared := true;
      end;
      crTriggerExtract.Active := false;
      crProcExtract.Active := false;
      dsqlProcExtract.Prepared := false;
    finally
      Screen.Cursor := crDefault;
    end;
  end;
end;

procedure TfrmBrowse.IB_ConnectionSourceConnectedChanged(
  Sender: TIB_ConnectionLink; AConnection: TIB_Connection);
begin
  lbRelations.Items.Clear;
end;

procedure TfrmBrowse.IB_ConnectionSourceAfterExecDDL(
  Sender: TIB_ConnectionLink; AConnection: TIB_Connection);
begin
  { Need to invalidate any flags that are caching metadata information. }
  lbRelations.Items.Clear;
end;

procedure TfrmBrowse.lbRelationsClick(Sender: TObject);
begin
  with crRelations, lbRelations do begin
    SQLFrom.Text := 'FROM ' + Items[ ItemIndex ];
    Prepared := true;
    pcRelExtractChange(Sender);
    crTriggerExtract.Prepared := true;
    crTriggerExtract.Active := false;
    crProcExtract.Prepared := true;
    crProcExtract.Active := false;
    with crRelDesc do begin
      Prepared := true;
      ParamByName( 'RELATION_NAME' ).AsString := Items[ ItemIndex ];
      First;
    end;
  end;
end;

procedure TfrmBrowse.lbRelationsKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  lbRelationsClick(Sender);
end;

procedure TfrmBrowse.cbDomainInfoClick(Sender: TObject);
begin
  sgExtractFields.DomainInfo := cbDomainInfo.Checked;
end;

procedure TfrmBrowse.lbTriggersClick(Sender: TObject);
begin
  if lbTriggers.Items.Count > 0 then begin
    with crTriggerExtract, lbRelations do begin
      Prepared := true;
      Active := false;
      ParamByName( 'TRIGGER_NAME' ).AsString :=
        lbTriggers.Items[ lbTriggers.ItemIndex ];
      ParamByName( 'RELATION_NAME' ).AsString :=
        lbRelations.Items[ lbRelations.ItemIndex ];
      First;
    end;
  end;
end;

procedure TfrmBrowse.lbTriggersKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  lbTriggersClick( Sender );
end;

procedure TfrmBrowse.lbProceduresClick(Sender: TObject);
var
  ExecProcSQL: string;
begin
  with crProcExtract do begin
    with crProcParams do begin
      Prepared := true;
      Active := false;
    end;
    Prepared := true;
    Active := false;
    ParamByName( 'PROCEDURE_NAME' ).AsString :=
      lbProcedures.Items[ lbProcedures.ItemIndex ];
    First;
    if EOF then begin
      dsqlProcExtract.Prepared := false;
    end else begin
      ExecProcSQL := 'EXECUTE PROCEDURE ' +
                     lbProcedures.Items[ lbProcedures.ItemIndex ];
      with crProcParams do begin
        First;
        while not EOF do begin
          ExecProcSQL := ExecProcSQL + '?' +
                         FieldByName( 'RDB$PARAMETER_NAME' ).AsString;
          Next;
          if not EOF then begin
            ExecProcSQL := ExecProcSQL + ', ';
          end;
        end;
      end;
      dsqlProcExtract.SQL.Text := ExecProcSQL;
      dsqlProcExtract.Prepare;
    end;
  end;
end;

procedure TfrmBrowse.lbProceduresKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  lbProceduresClick( Sender );
end;

procedure TfrmBrowse.btEditTriggerClick(Sender: TObject);
begin
  with crTriggerExtract, Fields do begin
    if Active and not EOF then begin
      with FieldByName( 'RDB$TRIGGER_SOURCE' ) as TIB_ColumnBlob do begin
        with tfrmDSQL.Create( Self ) do begin
          IB_Connection := Self.IB_Connection;
          IB_Transaction := Self.IB_Transaction;
          BaseKey := Self.FullKey + '\Edit Trigger';
          AsStream.Position := 0;
          meDSQL.Lines.LoadFromStream( AsStream );
          meDSQL.Lines.Text :=  'ALTER TRIGGER ' +
                                FieldByName( 'RDB$TRIGGER_NAME' ).AsString +
                                #13#10 +
                                meDSQL.Lines.Text;
          Show;
        end;
      end;
    end else begin
      ShowMessage( 'Invalid trigger source.' );
    end;
  end;
end;

procedure TfrmBrowse.btEditProcClick(Sender: TObject);
begin
  with crProcExtract, Fields do begin
    if Active and not EOF then begin
      with FieldByName('RDB$PROCEDURE_SOURCE') as TIB_ColumnBlob do begin
        AsStream.Position := 0;
        with tfrmDSQL.Create( Self ) do begin
          IB_Connection := Self.IB_Connection;
          IB_Transaction := Self.IB_Transaction;
          BaseKey := Self.FullKey + '\Edit Trigger';
          meDSQL.Lines.Text :=
            IB_Parse.GetStoredProcedureSource(
              true,  // Is an ALTER PROCEDURE statement
              FieldByName( 'RDB$PROCEDURE_NAME' ).AsString,
              dsqlProcExtract,
              AsString );
          Show;
        end;
      end;
    end else begin
      ShowMessage( 'Invalid procedure source.' );
    end;
  end;
end;

procedure TfrmBrowse.RelationsClick(Sender: TObject);
begin
  with IB_ConnectionSource.IB_Connection, crRelations, lbRelations do begin
    Prepared := false;
    if (Sender = cbSystem) or (Sender = rbTables) or (Sender = rbViews) or
       (Items.Count = 0) then begin
      SchemaRelationNames( IB_Connection, IB_Transaction,
                           cbSystem.Checked, rbTables.Checked, rbViews.Checked,
                           Items );
    end;
    pcRelExtractChange(Sender);
  end;
end;

procedure TfrmBrowse.pcRelExtractChange(Sender: TObject);
begin
  with crRelations, lbRelations, IB_ConnectionSource, IB_Connection do begin
    if ItemIndex >= 0 then begin
      if pcRelExtract.ActivePage = tsIndicies then begin
        SchemaIndexInfo( IB_Connection,
                         IB_Transaction,
                         meIndicies.Lines,
                         Items[ ItemIndex ] );
      end;
      if pcRelExtract.ActivePage = tsConstraints then begin
        SchemaConstraintInfo( IB_Connection,
                              IB_Transaction,
                              meConstraints.Lines,
                              Items[ ItemIndex ] );
      end;
      if pcRelExtract.ActivePage = tsTriggers then begin
        SchemaTriggerInfo( IB_Connection,
                           IB_Transaction,
                           lbTriggers.Items,
                           Items[ ItemIndex ] );
      end;
    end else begin
      meIndicies.Lines.Clear;
      meConstraints.Lines.Clear;
      lbTriggers.Items.Clear;
      lbTriggers.ItemIndex := -1;
    end;
  end;
end;

procedure TfrmBrowse.pnSizerRelationsMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  PanelSizing := true;
end;

procedure TfrmBrowse.pnSizerRelationsMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
  if PanelSizing then if Sender = pnSizerRelations then begin
    lbRelations.Width := lbRelations.Width + X;
  end else if Sender = pnSizerTriggers then begin
    lbTriggers.Width := lbTriggers.Width + X;
  end else if Sender = pnSizerProcedures then begin
    lbProcedures.Width := lbProcedures.Width + X;
  end else if Sender = pnSizerDomains then begin
    lbDomains.Width := lbDomains.Width + X;
  end else if Sender = pnSizerGenerators then begin
    lbGenerators.Width := lbGenerators.Width + X;
  end;
end;

procedure TfrmBrowse.pnSizerRelationsMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if PanelSizing then if Sender = pnSizerRelations then begin
    lbRelations.Width := lbRelations.Width + X;
  end else if Sender = pnSizerTriggers then begin
    lbTriggers.Width := lbTriggers.Width + X;
  end else if Sender = pnSizerProcedures then begin
    lbProcedures.Width := lbProcedures.Width + X;
  end else if Sender = pnSizerDomains then begin
    lbDomains.Width := lbDomains.Width + X;
  end else if Sender = pnSizerGenerators then begin
    lbGenerators.Width := lbGenerators.Width + X;
  end;
  PanelSizing := false;
end;

procedure TfrmBrowse.FormDestroy(Sender: TObject);
begin
  try
    WriteOutSettings;
  except
    Application.HandleException( Self );
  end;
end;

procedure TfrmBrowse.dsRelationsStateChanged(Sender: TIB_DataSource;
  ADataSet: TIB_DataSet);
begin
  cgBrowse.Visible := dsRelations.State <> dsSearch;
  spBrowse.Visible := dsRelations.State = dsSearch;
end;

procedure TfrmBrowse.IB_SearchBar1AfterAction(Sender: TObject);
begin
  if dsrelations.State = dsSearch then begin
    pcRelExtract.Activepage := tsData;
  end;
end;

procedure TfrmBrowse.dsTriggerExtractStateChanged(Sender: TIB_DataSource;
  ADataSet: TIB_DataSet);
begin
  inherited;
  with crTriggerExtract do begin
    btEditTrigger.Enabled := Active and not EOF and not BOF;
  end
end;

procedure TfrmBrowse.dsProcExtractStateChanged(Sender: TIB_DataSource;
  ADataSet: TIB_DataSet);
begin
  with crProcExtract do begin
    btEditProc.Enabled := Active and not EOF and not BOF;
  end
end;

end.

