unit
  FRM_IB_DSQL;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ComCtrls, Grids,

  FRM_IB_Base,

  IB_Components,
  IB_ConnectionSource,
  IB_TransactionSource,
  IB_StatementGrid,
  IB_TransactionBar,
  IB_StatementBar;

type
  TfrmDSQL = class(TfrmBase)
    DSQLStatementPanel: TPanel;
    btSQLPrevious: TButton;
    btSQLNext: TButton;
    sbStatementBar: TIB_StatementBar;
    btNewSQL: TButton;
    tbDSQL: TIB_TransactionBar;
    Panel6: TPanel;
    pcDSQL: TPageControl;
    tsDSQLStatement: TTabSheet;
    meDSQL: TMemo;
    tsDSQLInput: TTabSheet;
    IB_StatementGrid1: TIB_StatementGrid;
    tsDSQLOutput: TTabSheet;
    IB_StatementGrid2: TIB_StatementGrid;
    Panel11: TPanel;
    dsqlEdit: TIB_DSQL;
    procedure IB_TransactionSourceAfterAssignment(
      Sender: TIB_TransactionLink; ATransaction: TIB_Transaction);
    procedure IB_ConnectionSourceAfterAssignment(
      Sender: TIB_ConnectionLink; AConnection: TIB_Connection);
    procedure dsqlEditBeforePrepare(Sender: TIB_Statement);
    procedure meDSQLChange(Sender: TObject);
    procedure btNewSQLClick(Sender: TObject);
    procedure btSQLPreviousClick(Sender: TObject);
    procedure btSQLNextClick(Sender: TObject);
    procedure dsqlEditAfterUnprepare(Sender: TIB_Statement);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    procedure UpdateDSQLButtons;
  public
    { Public declarations }
  end;

implementation

{$R *.DFM}

procedure TfrmDSQL.FormCreate(Sender: TObject);
begin
  inherited;
  SetDefaultBounds( 0, 0, 500, 500 );
end;

procedure TfrmDSQL.IB_TransactionSourceAfterAssignment(
  Sender: TIB_TransactionLink; ATransaction: TIB_Transaction);
begin
  tbDSQL.IB_Transaction := ATransaction;
  dsqlEdit.IB_Transaction := ATransaction;
end;

procedure TfrmDSQL.IB_ConnectionSourceAfterAssignment(
  Sender: TIB_ConnectionLink; AConnection: TIB_Connection);
begin
  dsqlEdit.IB_Connection := AConnection;
end;

{------------------------------------------------------------------------------}

procedure TfrmDSQL.dsqlEditBeforePrepare(Sender: TIB_Statement);
begin
  dsqlEdit.SQL.Text := meDSQL.Lines.Text;
end;

procedure TfrmDSQL.meDSQLChange(Sender: TObject);
begin
  dsqlEdit.Prepared := false;
end;

procedure TfrmDSQL.btNewSQLClick(Sender: TObject);
begin
  with dsqlEdit do begin
    SQLHistoryRef := SQLHistoryCount;
    Prepared := false;
  end;
  meDSQL.Lines.Clear;
  pcDSQL.ActivePage := tsDSQLStatement;
  meDSQL.SetFocus;
  UpdateDSQLButtons;
end;

procedure TfrmDSQL.btSQLPreviousClick(Sender: TObject);
begin
  with dsqlEdit do begin
    SQLHistoryRef := SQLHistoryRef - 1;
  end;
  meDSQL.Lines.Text := dsqlEdit.SQL.Text;
  pcDSQL.ActivePage := tsDSQLStatement;
  meDSQL.SetFocus;
  UpdateDSQLButtons;
end;

procedure TfrmDSQL.btSQLNextClick(Sender: TObject);
begin
  with dsqlEdit do begin
    SQLHistoryRef := SQLHistoryRef + 1;
  end;
  meDSQL.Lines.Text := dsqlEdit.SQL.Text;
  pcDSQL.ActivePage := tsDSQLStatement;
  meDSQL.SetFocus;
  UpdateDSQLButtons;
end;

procedure TfrmDSQL.dsqlEditAfterUnprepare(Sender: TIB_Statement);
begin
  UpdateDSQLButtons;
end;

procedure TfrmDSQL.UpdateDSQLButtons;
begin
  with dsqlEdit do begin
    btSQLPrevious.Enabled := ( SQLHistoryCount > 0 ) and ( SQLHistoryRef > 0 );
    btSQLNext.Enabled := ( SQLHistoryCount > SQLHistoryRef + 1 );
  end;
end;

end.

