unit FRM_IB_Events;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls, ExtCtrls,
  
  FRM_IB_Base,

  IB_Components,
  IB_ConnectionSource,
  IB_TransactionSource,
  IB_Events;

type
  TfrmEvents = class(TfrmBase)
    meEvents: TMemo;
    Panel25: TPanel;
    btRegEvents: TButton;
    btClearResults: TButton;
    meEventResults: TMemo;
    Panel32: TPanel;
    Panel37: TPanel;
    IB_Events: TIB_Events;
    procedure FormCreate(Sender: TObject);
    procedure btRegEventsClick(Sender: TObject);
    procedure meEventsChange(Sender: TObject);
    procedure IB_EventsAfterRegister(Sender: TObject);
    procedure IB_EventsAfterUnregister(Sender: TObject);
    procedure IB_EventsBeforeRegister(Sender: TObject);
    procedure IB_EventsEventAlert( Sender: TObject;
                                   EventName: string;
                                   EventCount: Longint);
    procedure btClearResultsClick(Sender: TObject);
    procedure IB_ConnectionSourceAfterAssignment(
      Sender: TIB_ConnectionLink; AConnection: TIB_Connection);
  private
    { Private declarations }
  protected
    procedure DoReadSettings; override;
    procedure DoWriteSettings; override;
  public
    { Public declarations }
  end;

implementation

{$R *.DFM}

procedure TfrmEvents.FormCreate(Sender: TObject);
begin
  inherited;
  SetDefaultBounds( 0, 0, 400, 200 );
end;

procedure TfrmEvents.DoReadSettings;
begin
  ReadStrings( 'Events', meEvents.Lines );
end;

procedure TfrmEvents.DoWriteSettings;
begin
  WriteStrings( 'Events', meEvents.Lines );
end;

procedure TfrmEvents.IB_ConnectionSourceAfterAssignment(
  Sender: TIB_ConnectionLink; AConnection: TIB_Connection);
begin
  IB_Events.IB_Connection := AConnection;
end;

{------------------------------------------------------------------------------}

procedure TfrmEvents.btRegEventsClick(Sender: TObject);
begin
  with IB_Events do Registered := not Registered;
end;

procedure TfrmEvents.meEventsChange(Sender: TObject);
begin
  IB_Events.Registered := false;
end;

procedure TfrmEvents.IB_EventsAfterRegister(Sender: TObject);
begin
  btRegEvents.Caption := 'Unregister';
end;

procedure TfrmEvents.IB_EventsAfterUnregister(Sender: TObject);
begin
  btRegEvents.Caption := 'Register';
end;

procedure TfrmEvents.IB_EventsBeforeRegister(Sender: TObject);
begin
  IB_Events.Events.Text := meEvents.Lines.Text;
end;

procedure TfrmEvents.IB_EventsEventAlert(Sender: TObject;
  EventName: string; EventCount: Longint);
begin
  meEventResults.Lines.Insert( 0, EventName + ': ' +
                                  IntToStr( EventCount ) + '  -  ' +
                                  DateTimeToStr( now ) );
end;

procedure TfrmEvents.btClearResultsClick(Sender: TObject);
begin
  meEventResults.Lines.Clear;
end;

end.

