unit
  FRM_IB_Parameters;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, 
  StdCtrls, ExtCtrls, Grids, Buttons, Dialogs, ComCtrls, DsgnIntf, 

  FRM_IB_Base,
  
  IB_Header,
  IB_Components,
  IB_StatementGrid,
  IB_ConnectionSource,
  IB_TransactionSource;

type
  TfrmParameters = class(TfrmBase)
    sgParameters: TIB_StatementGrid;
  private
  public
  end;

var
  frmParameters: TfrmParameters;

type
  TParametersPropertyEditor = class(TPropertyEditor)
  public
    procedure Edit; override;
    function GetValue: string; override;
    function GetAttributes: TPropertyAttributes; override;
  end;

implementation

{$R *.DFM}

function TParametersPropertyEditor.GetValue: string;
begin
  Result := '(TIB_XSQLDA)';
end;

function TParametersPropertyEditor.GetAttributes: TPropertyAttributes;
begin
  Result := [ paDialog, paReadOnly ];
end;

procedure TParametersPropertyEditor.Edit;
var
  Statement: TIB_Statement;
  IsChanged: boolean;
begin
  Statement := GetComponent(0) as TIB_Statement;
  IsChanged := false;
  if not Statement.Prepared then begin
    try
      Statement.Prepare;
    except
      { Do not show any exception! }
    end;
  end;
  if Statement.Prepared then begin
    if Statement.ParamCount > 0 then begin
      with TfrmParameters.Create( Application ) do try
        Caption := Statement.Owner.Name + '.' +
                   Statement.Name       + ' - ' +
                   Caption;
        BaseKey := 'Software\IB Objects\Parameter Editor';
        sgParameters.Statement := Statement;
        if ShowModal = idOK then begin
          sgParameters.PostChanges;
          sgParameters.Statement := nil;
          IsChanged := true;
        end;
      finally
        Free;
      end;
    end else begin
      MessageBeep( 1 );
      ShowMessage( 'Statement has no Params.' );
    end;
    if IsChanged then begin
      Designer.Modified;
    end;
  end else begin
    MessageBeep( 1 );
    ShowMessage( 'Statement failed to prepare.' );
  end;
end;

end.


