
{                                                                              }
{  FRM_IB_WISQL                                                                }
{                                                                              }

unit
  FRM_IB_WISQL;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Spin,
  StdCtrls, ExtCtrls, Grids, Buttons, Dialogs, ComCtrls, Mask, Registry,

  FRM_IB_Base,

  IB_Components, IB_StatementBar, IB_SearchBar, IB_UpdateBar, IB_NavigationBar,
  IB_DataSetBar, IB_TransactionBar, IB_ConnectionBar, IB_StatementGrid,
  IB_CursorGrid, IB_TransactionSource, IB_StatementSource, IB_ConnectionSource,
  IB_SearchPanel;
  
type
  TfrmWISQL = class(TfrmBase)
    pcIB_WISQL: TPageControl;
    tsCursor: TTabSheet;
    tsConnection: TTabSheet;
    Panel1: TPanel;
    edUserName: TEdit;
    edPassword: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Panel2: TPanel;
    CursorStatementPanel: TPanel;
    cbCreateDrop: TIB_ConnectionBar;
    tsDSQL: TTabSheet;
    DSQLStatementPanel: TPanel;
    btSQLPrevious: TButton;
    btSQLNext: TButton;
    Panel4: TPanel;
    pcCursor: TPageControl;
    tsCursorSQL: TTabSheet;
    meCursor: TMemo;
    tsCursorInput: TTabSheet;
    tsCursorFields: TTabSheet;
    sbStatementBar: TIB_StatementBar;
    dsbCursorBar: TIB_DataSetBar;
    Panel6: TPanel;
    btNewSQL: TButton;
    stIB_Cursor: TIB_StatementSource;
    stIB_DSQL: TIB_StatementSource;
    dsIB_Cursor: TIB_DataSource;
    pcDSQL: TPageControl;
    tsDSQLStatement: TTabSheet;
    tsDSQLInput: TTabSheet;
    tsDSQLOutput: TTabSheet;
    meDSQL: TMemo;
    IB_StatementGrid1: TIB_StatementGrid;
    IB_StatementGrid2: TIB_StatementGrid;
    IB_CursorParameterGrid: TIB_StatementGrid;
    cbDatabase: TComboBox;
    SpeedButton1: TSpeedButton;
    cbRemember: TCheckBox;
    Label4: TLabel;
    seBuffers: TSpinEdit;
    nbNavigationBar: TIB_NavigationBar;
    ubUpdateBar: TIB_UpdateBar;
    sbSearchBar: TIB_SearchBar;
    Panel5: TPanel;
    tsTransaction: TTabSheet;
    Panel3: TPanel;
    Panel7: TPanel;
    Panel8: TPanel;
    ScrollBox3: TScrollBox;
    cbAutoStart: TCheckBox;
    cbReadOnly: TCheckBox;
    rgIsolation: TRadioGroup;
    cbLockWait: TCheckBox;
    cbAutoCommit: TCheckBox;
    Panel9: TPanel;
    Panel11: TPanel;
    Panel12: TPanel;
    Panel14: TPanel;
    edAllocatedpages: TEdit;
    edImplementation: TEdit;
    edLevel: TEdit;
    edODS: TEdit;
    edVersion: TEdit;
    Label5: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label12: TLabel;
    Label6: TLabel;
    edPageSize: TEdit;
    odGDB: TOpenDialog;
    tsCursorOutput: TTabSheet;
    cgCursor: TIB_CursorGrid;
    IB_CursorStatementGrid: TIB_StatementGrid;
    cbConnectDisconnect: TIB_ConnectionBar;
    cbDBKeyScope: TCheckBox;
    tsQueryForms: TTabSheet;
    ScrollBox2: TScrollBox;
    lbQueryFormNames: TListBox;
    edNewQueryForm: TEdit;
    btNewQueryForm: TButton;
    btLaunchQueryForm: TButton;
    btRemoveQueryForm: TButton;
    cbForcedWrites: TCheckBox;
    cbReservePageSpace: TCheckBox;
    tsLayouts: TTabSheet;
    ScrollBox4: TScrollBox;
    lbLayouts: TListBox;
    edNewlayout: TEdit;
    btNewlayout: TButton;
    btRemoveLayout: TButton;
    btAbout: TButton;
    btBrowse: TButton;
    meCursorPlan: TMemo;
    crEdit: TIB_Cursor;
    dsqlEdit: TIB_DSQL;
    IB_TransactionBar: TIB_TransactionBar;
    tbDSQL: TIB_TransactionBar;
    btMonitor: TButton;
    btScript: TButton;
    btExport: TButton;
    btEvents: TButton;
    ssForEdit: TIB_StatementSource;
    dsForEdit: TIB_DataSource;
    csForEdit: TIB_ConnectionSource;
    tsForEdit: TIB_TransactionSource;
    cnEdit: TIB_Connection;
    trEdit: TIB_TransactionSingle;
    spIB_Cursor: TIB_SearchPanel;
    procedure FormCreate(Sender: TObject);
    procedure sbNewConnection(Sender: TObject);
    procedure btSQLPreviousClick(Sender: TObject);
    procedure btSQLNextClick(Sender: TObject);
    procedure cbAutoStartClick(Sender: TObject);
    procedure IB_ConnectionSourceBeforeConnect(Sender: TIB_ConnectionLink;
      IB_Connection: TIB_Connection);
    procedure IB_ConnectionSourceConnectedChanged(
      Sender: TIB_ConnectionLink; IB_Connection: TIB_Connection);
    procedure IB_ConnectionSourceBeforeDropDatabase(
      Sender: TIB_ConnectionLink; IB_Connection: TIB_Connection);
    procedure stIB_CursorBeforePrepare(
      Sender: TIB_StatementLink; IB_Statement: TIB_Statement);
    procedure stIB_DSQLBeforePrepare(Sender: TIB_StatementLink;
      IB_Statement: TIB_Statement);
    procedure meCursorChange(Sender: TObject);
    procedure btNewSQLClick(Sender: TObject);
    procedure stIB_DSQLAfterUnprepare(Sender: TIB_StatementLink;
      IB_Statement: TIB_Statement);
    procedure cbDatabaseChange(Sender: TObject);
    procedure IB_ConnectionSourceAfterConnect(Sender: TIB_ConnectionLink;
      IB_Connection: TIB_Connection);
    procedure IB_ConnectionSourceBeforeCreateDatabase(
      Sender: TIB_ConnectionLink; IB_Connection: TIB_Connection);
    procedure btAboutClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure stIB_CursorAfterPrepare(
      Sender: TIB_StatementLink; Statement: TIB_Statement);
    procedure dsIB_CursorStateChanged(Sender: TIB_DataSource;
      AIB_DataSet: TIB_DataSet);
    procedure IB_TransactionSourceBeforeStart(Sender: TIB_TransactionLink;
      T: TIB_Transaction);
    procedure TransactionPropChanged(Sender: TObject);
    procedure cbAutoCommitClick(Sender: TObject);
    procedure nbNavigationBarBeforeAction(Sender: TObject);
    procedure cbLayoutChange(Sender: TObject);
    procedure btNewQueryFormClick(Sender: TObject);
    procedure lbQueryFormNamesDblClick(Sender: TObject);
    procedure IB_ConnectionSourceBeforeDisconnect(Sender: TIB_ConnectionLink;
      IB_Connection: TIB_Connection);
    procedure btRemoveQueryFormClick(Sender: TObject);
    procedure lbLayoutsKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure btNewlayoutClick(Sender: TObject);
    procedure btRemoveLayoutClick(Sender: TObject);
    procedure btBrowseClick(Sender: TObject);
    procedure IB_ConnectionSourceAfterAssignment(
      Sender: TIB_ConnectionLink; AConnection: TIB_Connection);
    procedure IB_TransactionSourceAfterAssignment(
      Sender: TIB_TransactionLink; ATransaction: TIB_Transaction);
    procedure btMonitorClick(Sender: TObject);
    procedure btScriptClick(Sender: TObject);
    procedure btExportClick(Sender: TObject);
    procedure btEventsClick(Sender: TObject);
    procedure meDSQLChange(Sender: TObject);
  private
    procedure UpdateDSQLButtons;
    procedure UpdateLayoutList;
    procedure CloseChildForms;
  protected
    procedure DoReadSettings; override;
    procedure DoWriteSettings; override;
    procedure SetLayout( AValue: string ); override;
    procedure DoReadLayout; override;
    procedure DoWriteLayout; override;
    procedure AddLayout( NewLayout: string ); override;
    procedure RemoveLayout( OldLayout: string ); override;
  public
    procedure UpdateCaption;
  end;

implementation

{$R *.DFM}

uses
  DLG_IB_About,
  FRM_IB_Browse,
  FRM_IB_Events,
  FRM_IB_Monitor,
  FRM_IB_Export,
  FRM_IB_Script,
  FRM_IB_Query,
  IB_Schema,
  IB_Parse;

{------------------------------------------------------------------------------}
{   Form                                                                       }
{------------------------------------------------------------------------------}

procedure TfrmWISQL.FormCreate(Sender: TObject);
begin
  inherited;
  SetDefaultBounds( 0, 0, 550, 350 );
  if ParamStr(1) <> '' then begin
    cbDatabase.Text := ParamStr(1);
    if ParamStr(2) <> '' then begin
      edUserName.Text := ParamStr(2);
    end else begin
      edUserName.Text := 'SYSDBA';
    end;
    if ParamStr(3) <> '' then begin
      edPassword.Text := ParamStr(3);
    end else begin
      edPassword.Text := 'masterkey';
    end;
  end;
  pcDSQL.ActivePage := tsDSQLStatement;
  pcCursor.ActivePage := tsCursorSQL;
  IB_Connection := cnEdit;
  IB_Transaction := trEdit;
end;

procedure TfrmWISQL.IB_ConnectionSourceAfterAssignment(
  Sender: TIB_ConnectionLink; AConnection: TIB_Connection);
begin
  cbCreateDrop.IB_Connection := AConnection;
  cbConnectDisconnect.IB_Connection := AConnection;
  crEdit.IB_Connection := AConnection;
  dsqlEdit.IB_Connection := AConnection;
  trEdit.IB_Connection := AConnection; 
end;

procedure TfrmWISQL.IB_TransactionSourceAfterAssignment(
  Sender: TIB_TransactionLink; ATransaction: TIB_Transaction);
begin
  IB_TransactionBar.IB_Transaction := ATransaction;
  tbDSQL.IB_Transaction := ATransaction;
  crEdit.IB_Transaction := ATransaction;
  dsqlEdit.IB_Transaction := ATransaction;
end;

procedure TfrmWISQL.FormClose( Sender: TObject; var Action: TCloseAction);
begin
  inherited;
  if IB_Transaction <> nil then begin
    if IB_Transaction.CloseWithConfirm <> mrCancel then begin
      if IB_Connection <> nil then begin
        IB_Connection.Connected := false;
      end;
    end else begin
      Action := caNone;
    end;
  end;
end;

procedure TfrmWISQL.DoReadSettings;
begin
  with RegDB, pcIB_WISQL do begin
    ActivePage := Pages[ ReadInteger('Settings', 'Page Index', 0) ];
  end;
  if csForEdit.IB_Connection <> nil then begin
    with csForEdit.IB_Connection do begin
      cnEdit.Database         := Database;
      cnEdit.Password         := Password;
      cnEdit.Username         := Username;
      cnEdit.DBKeyScope       := DBKeyScope;
      cnEdit.Buffers          := Buffers;
      cnEdit.ForcedWrites     := ForcedWrites;
      cnEdit.ReservePageSpace := ReservePageSpace;
    end;
    pcIB_WISQL.ActivePage := tsConnection;
  end;
  if tsForEdit.IB_Transaction <> nil then begin
    with tsForEdit.IB_Transaction do begin
      trEdit.AnnounceFocus := AnnounceFocus;
      trEdit.AutoCommit    := AutoCommit;
      trEdit.AutoStart     := AutoStart;
      trEdit.DDL_Commit    := DDL_Commit;
      trEdit.DDL_PostAll   := DDL_PostAll;
      trEdit.ReadOnly      := ReadOnly;
      trEdit.LockWait      := LockWait;
      trEdit.Isolation     := Isolation;
      trEdit.RecVersion    := RecVersion;
    end;
    pcIB_WISQL.ActivePage := tsTransaction;
  end;
  if ssForEdit.Statement <> nil then with ssForEdit.Statement do begin
    dsqlEdit.SQL.Text := SQL.Text;
    pcIB_WISQL.ActivePage := tsDSQL;
  end;
  if dsForEdit.DataSet <> nil then with dsForEdit.DataSet do begin
    crEdit.SQL.Text := SQL.Text;
    pcIB_WISQL.ActivePage := tsCursor;
  end;
  if ( ParamStr(1) <> '' ) then begin
    RegDB.WriteString( 'Settings', 'LAYOUT', '' );
  end;
  if ( csForEdit.IB_Connection <> nil ) or
     ( tsForEdit.IB_Transaction <> nil ) or
     ( ssForEdit.Statement <> nil ) or
     ( dsForEdit.DataSet <> nil ) then begin
    RegDB.WriteString( 'Settings', 'LAYOUT', 'Editor' );
  end;
  UpdateLayoutList;
end;

procedure TfrmWISQL.DoWriteSettings;
begin
  with RegDB, pcIB_WISQL do begin
    WriteInteger('Settings', 'Page Index', ActivePage.PageIndex );
  end;
  if csForEdit.IB_Connection <> nil then begin
    with csForEdit.IB_Connection do begin
      Database         := cnEdit.Database;
      Password         := cnEdit.Password;
      Username         := cnEdit.Username;
      DBKeyScope       := cnEdit.DBKeyScope;
      Buffers          := cnEdit.Buffers;
      ForcedWrites     := cnEdit.ForcedWrites;
      ReservePageSpace := cnEdit.ReservePageSpace;
    end;
  end;
  if tsForEdit.IB_Transaction <> nil then begin
    with tsForEdit.IB_Transaction do begin
      AnnounceFocus := trEdit.AnnounceFocus;
      AutoCommit    := trEdit.AutoCommit;
      AutoStart     := trEdit.AutoStart;
      DDL_Commit    := trEdit.DDL_Commit;
      DDL_PostAll   := trEdit.DDL_PostAll;
      ReadOnly      := trEdit.ReadOnly;
      LockWait      := trEdit.LockWait;
      Isolation     := trEdit.Isolation;
      RecVersion    := trEdit.RecVersion;
    end;
  end;
  if ssForEdit.Statement <> nil then with ssForEdit.Statement do begin
    SQL.Text := dsqlEdit.SQL.Text;
  end;
  if dsForEdit.DataSet <> nil then with dsForEdit.DataSet do begin
    SQL.Text := crEdit.SQL.Text;
  end;
end;

procedure TfrmWISQL.AddLayout( NewLayout: string );
begin
  inherited AddLayout( NewLayout );
  UpdateLayoutList;
end;

procedure TfrmWISQL.RemoveLayout( OldLayout: string );
begin
  inherited RemoveLayout( OldLayout );
  UpdateLayoutList;
end;

procedure TfrmWISQL.SetLayout( AValue: string );
var
  OldCursor: TCursor;
begin
  if Layout <> AValue then begin
    OldCursor := Screen.Cursor;
    try
      Screen.Cursor := crHourglass;
      CloseChildForms;
      inherited SetLayout( AValue );
      UpdateCaption;
      UpdateLayoutList;
    finally
      Screen.Cursor := OldCursor;
    end;
  end;
end;

{------------------------------------------------------------------------------}
{  Layout tab                                                                  }
{------------------------------------------------------------------------------}

procedure TfrmWISQL.UpdateCaption;
begin
  if IB_Connection.Connected then begin
    Caption := IB_Connection.Database;
  end else if Layout <> '' then begin
    Caption := Layout;
  end else begin
    Caption := Application.Title;
  end;
  if ssForEdit.Statement <> nil then begin
    Caption := ssForEdit.Statement.Owner.Name + '.' +
               ssForEdit.Statement.Name + ' - Editor';
  end else if dsForEdit.DataSet <> nil then begin
    Caption := dsForEdit.DataSet.Owner.Name + '.' +
               dsForEdit.DataSet.Name + ' - Editor';
  end else if csForEdit.IB_Connection <> nil then begin
    Caption := csForEdit.IB_Connection.Owner.Name + '.' +
               csForEdit.IB_Connection.Name + ' - Editor';
  end else if tsForEdit.IB_Transaction <> nil then begin
    Caption := tsForEdit.IB_Transaction.Owner.Name + '.' +
               tsForEdit.IB_Transaction.Name + ' - Editor';
  end;
end;

procedure TfrmWISQL.UpdateLayoutList;
begin
  with lbLayouts do begin
    Items.Text := LayoutNames.Text;
    ItemIndex := Items.IndexOf( Layout );
  end;
end;

procedure TfrmWISQL.btNewLayoutClick(Sender: TObject);
begin
  with lbLayouts do begin
    if ( Trim( edNewLayout.Text ) = '' ) or
       ( Items.IndexOf( edNewLayout.Text ) <> -1 ) then begin
      MessageBeep( 0 );
    end else begin
      AddLayout( edNewLayout.Text );
      UpdateLayoutList;
      edNewLayout.Text := '';
    end;
  end;
end;

procedure TfrmWISQL.btRemoveLayoutClick(Sender: TObject);
begin
  with lbLayouts do begin
    if ItemIndex >= 0 then begin
      RemoveLayout( Items[ ItemIndex ] );
      UpdateLayoutList;
    end;
  end;
end;

procedure TfrmWISQL.CloseChildForms;
var
  ii: integer;
begin
  for ii := Screen.FormCount - 1 downto 0 do begin
    try
      if ( Screen.Forms[ ii ] is TfrmQuery  ) or
         ( Screen.Forms[ ii ] is TfrmBrowse ) or
         ( Screen.Forms[ ii ] is TfrmEvents ) or
         ( Screen.Forms[ ii ] is TfrmExport ) or
         ( Screen.Forms[ ii ] is TfrmScript ) then begin
        Screen.Forms[ ii ].Free;
      end;
    except
    end;
  end;
end;

procedure TfrmWISQL.DoReadLayout;
begin
  ReadStrings( 'Connections', cbDatabase.Items );
  ReadStrings( 'Query Names', lbQueryFormNames.Items );
  lbLayouts.ItemIndex := lbLayouts.Items.IndexOf( Layout );
  with cbDatabase do begin
    Text := '';
    if Items.Count > 0 then ItemIndex := 0;
  end;
  if csForEdit.IB_Connection <> nil then with cnEdit do begin
    edUserName.Text := Username;
    edPassword.Text := Password;
    cbRemember.Checked := false;
    case DBKeyScope of
      ksTransaction: cbDBKeyScope.State := cbUnchecked;
      ksConnection: cbDBKeyScope.State := cbChecked;
      ksDefault: cbDBKeyScope.State := cbGrayed;
    end;
    seBuffers.Value := Buffers;
    case ForcedWrites of
      fwTrue: cbForcedWrites.State := cbChecked;
      fwFalse: cbForcedWrites.State := cbUnchecked;
      fwDefault: cbForcedWrites.State := cbGrayed;
    end;
    case ReservePageSpace of
      rpsTrue: cbReservePageSpace.State := cbChecked;
      rpsFalse: cbReservePageSpace.State := cbUnchecked;
      rpsDefault: cbReservePageSpace.State := cbGrayed;
    end;
  end else with RegDB do begin
    edUserName.Text := ReadString( 'Settings', 'USER NAME', 'SYSDBA' );
    edPassword.Text := ReadString( 'Settings', 'PASSWORD', 'masterkey' );
    cbRemember.Checked := ReadString( 'Settings', 'PASSWORD', '' ) <> '';
    cbDBKeyScope.Checked := ReadBool( 'Settings', 'DBKEY SCOPE', false );
    seBuffers.Value := ReadInteger( 'Settings', 'BUFFERS', 75 );
    cbForcedWrites.State := cbGrayed;
    cbReservePageSpace.State := cbGrayed;
  end;
  if tsForEdit.IB_Transaction <> nil then with trEdit do begin
    cbAutoCommit.Checked := AutoCommit;
    cbAutoStart.Checked := AutoStart;
    cbReadOnly.Checked := ReadOnly;
    cbLockWait.Checked := LockWait;
    case Isolation of
      tiConcurrency: rgIsolation.ItemIndex := 0;
      tiConsistency: rgIsolation.ItemIndex := 1;
      tiCommitted:   if RecVersion then rgIsolation.ItemIndex := 2
                                   else rgIsolation.ItemIndex := 3;
    end;
  end else with RegDB do begin 
    cbAutoCommit.Checked := ReadBool( 'Settings', 'AutoCommit', false );
    cbAutoStart.Checked := ReadBool( 'Settings', 'AutoStart',  false );
    cbReadOnly.Checked := ReadBool( 'Settings', 'ReadOnly', false );
    cbLockWait.Checked := ReadBool( 'Settings', 'LockWait', false );
    rgIsolation.ItemIndex := ReadInteger( 'Settings', 'Isolation', 2 );
  end;
  if ssForEdit.Statement <> nil then begin
    meDSQL.Lines.Text := dsqlEdit.SQL.Text;
  end else begin
    ReadStrings( 'DSQL', meDSQL.Lines );
  end;
  if dsForEdit.DataSet <> nil then begin
    meCursor.Lines.Text := crEdit.SQL.Text;
  end else begin
    ReadStrings( 'Cursor', meCursor.Lines );
  end;
end;

procedure TfrmWISQL.DoWriteLayout;
begin
  WriteStrings( 'Connections', cbDatabase.Items );
  if csForEdit.IB_Connection <> nil then with cnEdit do begin
    Connected := false;
    Database := cbDatabase.Text;
    Username := edUserName.Text;
    if cbRemember.Checked then begin
      Password := edPassword.Text;
    end;
    Buffers := seBuffers.Value;
    case cbDBKeyScope.State of
      cbChecked:   DBKeyScope := ksConnection;
      cbUnchecked: DBKeyScope := ksTransaction;
      cbGrayed:    DBKeyScope := ksDefault;
    end;
    case cbForcedWrites.State of
      cbChecked:   ForcedWrites := fwTrue;
      cbUnchecked: ForcedWrites := fwFalse;
      cbGrayed:    ForcedWrites := fwDefault;
    end;
    case cbReservePageSpace.State of
      cbChecked:   ReservePageSpace := rpsTrue;
      cbUnchecked: ReservePageSpace := rpsFalse;
      cbGrayed:    ReservePageSpace := rpsDefault;
    end;
  end else with RegDB do begin
    WriteString( 'Settings', 'USER NAME', edUserName.Text );
    if cbRemember.Checked then begin
      WriteString( 'Settings', 'PASSWORD', edPassword.Text );
    end else begin
      edPassword.Text := '';
      WriteString( 'Settings', 'PASSWORD', '' );
    end;
    WriteBool( 'Settings', 'DBKEY SCOPE', cbDBKeyScope.Checked );
    WriteInteger( 'Settings', 'BUFFERS', seBuffers.Value );
  end;
  if tsForEdit.IB_Transaction <> nil then with trEdit do begin
    AutoCommit := cbAutoCommit.Checked;
    AutoStart := cbAutoStart.Checked;
    ReadOnly := cbReadOnly.Checked;
    LockWait := cbLockWait.Checked;
    case rgIsolation.ItemIndex of
    0: Isolation := tiConcurrency;
    1: Isolation := tiConsistency;
    2: begin
       Isolation := tiCommitted;
       RecVersion := true;
       end;
    3: begin
       Isolation := tiCommitted;
       RecVersion := false;
       end;
    end;
  end else with RegDB do begin
    WriteBool( 'Settings', 'AutoStart',  cbAutoStart.Checked );
    WriteBool( 'Settings', 'AutoCommit', cbAutoCommit.Checked );
    WriteBool( 'Settings', 'ReadOnly',   cbReadOnly.Checked );
    WriteBool( 'Settings', 'LockWait',   cbLockWait.Checked );
    WriteInteger( 'Settings', 'Isolation', rgIsolation.ItemIndex );
  end;
  if ssForEdit.Statement <> nil then with dsqlEdit do begin
    SQL.Text := meDSQL.Lines.Text;
  end else begin
    WriteStrings( 'DSQL', meDSQL.Lines );
  end;
  if dsForEdit.DataSet <> nil then with crEdit do begin
    SQL.Text := meCursor.Lines.Text;
  end else begin;
    WriteStrings( 'Cursor', meCursor.Lines );
  end;
end;

procedure TfrmWISQL.cbLayoutChange(Sender: TObject);
begin
  if IB_Connection <> nil then IB_Connection.Connected := false;
  with lbLayouts do begin
    Layout := Items[ ItemIndex ];
  end;
end;

procedure TfrmWISQL.lbLayoutsKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  cbLayoutChange( Sender );
end;

procedure TfrmWISQL.btAboutClick(Sender: TObject);
begin
  with TdlgAbout.Create( Application ) do try
    ShowModal;
  finally
    Free;
  end;
end;

{------------------------------------------------------------------------------}
{   Connection tab                                                             }
{------------------------------------------------------------------------------}

procedure TfrmWISQL.IB_ConnectionSourceBeforeDisconnect(
  Sender: TIB_ConnectionLink; IB_Connection: TIB_Connection);
begin
  CloseChildForms;
end;

procedure TfrmWISQL.IB_ConnectionSourceBeforeConnect(
  Sender: TIB_ConnectionLink; IB_Connection: TIB_Connection);
begin
  if IB_Connection <> nil then with IB_Connection do begin
    if ConnectionStatus = csConnectPending then begin
    // This is invoked when a database is created in the connection tab.
      Database := cbDatabase.Text;
      UserName := edUserName.Text;
      Password := edPassword.Text;
      Buffers  := seBuffers.Value;
      case cbForcedWrites.State of
        cbChecked:   ForcedWrites := fwTrue;
        cbUnchecked: ForcedWrites := fwFalse;
        cbGrayed:    ForcedWrites := fwDefault;
      end;
      case cbReservePageSpace.State of
        cbChecked:   ReservepageSpace := rpsTrue;
        cbUnchecked: ReservepageSpace := rpsFalse;
        cbGrayed:    ReservepageSpace := rpsDefault;
      end;
    end else begin
    // This is invoked when a script creates a new database.
      cbDatabase.Text := Database;
      edUserName.Text := UserName;
      edPassword.Text := Password;
      seBuffers.Value := Buffers;
    end;
  end;
end;

procedure TfrmWISQL.cbDatabaseChange(Sender: TObject);
begin
  if IB_Connection <> nil then begin
    IB_Connection.Connected := false;
  end;
end;

procedure TfrmWISQL.sbNewConnection(Sender: TObject);
begin
  if IB_Connection <> nil then with IB_Connection do begin
    Connected := false;
    if cbDatabase.Text <> '' then begin
      Database := cbDatabase.Text;
      odGDB.FileName := Path;
    end else begin
      odGDB.FileName := '*.GDB';
    end;
    if odGDB.Execute then begin
      Database := odGDB.FileName;
      cbDatabase.Text := Database;
    end;
  end;
end;

procedure TfrmWISQL.IB_ConnectionSourceAfterConnect(
  Sender: TIB_ConnectionLink; IB_Connection: TIB_Connection);
var
  ii: integer;
begin
  with cbDatabase, Items, IB_Connection do begin
    cbDatabase.OnChange := nil;
    try
      ii := IndexOf( Database );
      if ii <> -1 then begin
        Delete( ii );
      end;
      Insert( 0, Database );
      cbDatabase.Text := Database;
      edUsername.Text := UserName;
      edPassword.Text := Password;
    finally
      cbDatabase.OnChange := cbDatabaseChange;
    end;
  end;
end;

procedure TfrmWISQL.IB_ConnectionSourceConnectedChanged(
  Sender: TIB_ConnectionLink; IB_Connection: TIB_Connection);
begin
  btBrowse.Enabled := IB_Connection.Connected;
  btScript.Enabled := IB_Connection.Connected;
  btExport.Enabled := IB_Connection.Connected;
  btEvents.Enabled := IB_Connection.Connected;
  UpdateCaption;
  if IB_Connection.Connected then begin
    with IB_Connection.Characteristics do begin
      edAllocatedPages.Text := IntToStr( dbAllocation );
      edLevel.Text := IntToStr( dbLevelPrefix ) + '.' +
                      IntToStr( dbBase_Level ) + '.';
      edImplementation.Text := IntToStr( dbImplementationPrefix ) + '.' +
                               IntToStr( dbImplementation ) + '.' +
                               IntToStr( dbClass );
      with cbForcedWrites do begin
        OnClick := nil;
        try
          Checked := dbForced_writes <> 0;
        finally
          OnClick := cbDatabaseChange;
        end;
      end;
      with cbReservePageSpace do begin
        OnClick := nil;
        try
          Checked := dbNo_Reserve = 0;
        finally
          OnClick := cbDatabaseChange;
        end;
      end;
      edODS.Text := IntToStr( dbODS_Minor_Version ) + '.' +
                    IntToStr( dbODS_Version );
      edPageSize.Text := IntToStr( dbPage_Size );
      edVersion.Text := IntToStr( dbVersionPrefix ) + '.' + dbVersion;
    end;
  end else begin
    edAllocatedPages.Text    := '';
    edLevel.Text             := '';
    edImplementation.Text    := '';
    cbReservePageSpace.State := cbGrayed;
    cbForcedWrites.State     := cbGrayed;
    edODS.Text               := '';
    edPageSize.Text          := '';
    edVersion.Text           := '';
  end;
end;

procedure TfrmWISQL.IB_ConnectionSourceBeforeCreateDatabase(
  Sender: TIB_ConnectionLink; IB_Connection: TIB_Connection);
begin
  if MessageDlg( 'Are you sure you want to create this database?',
                 mtConfirmation,
                 mbOkCancel,
                 0 ) <> mrOk then begin
    SysUtils.Abort;
  end else begin
  end;
end;

procedure TfrmWISQL.IB_ConnectionSourceBeforeDropDatabase(
  Sender: TIB_ConnectionLink; IB_Connection: TIB_Connection);
begin
  if MessageDlg( 'Are you sure you want to drop this database?',
                 mtWarning,
                 mbOkCancel,
                 0 ) <> mrOk then begin
    SysUtils.Abort;
  end;
end;

{------------------------------------------------------------------------------}

procedure TfrmWISQL.btBrowseClick(Sender: TObject);
begin
  with TfrmBrowse.Create( Self ) do begin
    IB_Connection := Self.IB_Connection;
    IB_Transaction := Self.IB_Transaction;
    BaseKey := Self.FullKey + '\Browse';
    ReadInValues;
    Show;
  end;
end;

procedure TfrmWISQL.btEventsClick(Sender: TObject);
begin
  with TfrmEvents.Create( Self ) do begin
    IB_Connection := Self.IB_Connection;
    BaseKey := Self.FullKey + '\Events';
    Show;
  end;
end;

procedure TfrmWISQL.btExportClick(Sender: TObject);
begin
  with TfrmExport.Create( Self ) do begin
    IB_Connection := Self.IB_Connection;
    IB_Transaction := Self.IB_Transaction;
    BaseKey := Self.FullKey + '\Export';
    Show;
  end;
end;

procedure TfrmWISQL.btScriptClick(Sender: TObject);
begin
  with TfrmScript.Create( Self ) do begin
    IB_Connection := Self.IB_Connection;
    IB_Transaction := Self.IB_Transaction;
    BaseKey := Self.FullKey + '\Script';
    Show;
  end;
end;

procedure TfrmWISQL.btMonitorClick(Sender: TObject);
begin
  with TfrmMonitor.Create( Self ) do begin
    BaseKey := Self.BaseKey + '\Monitor';
    Show;
  end;
end;

{------------------------------------------------------------------------------}
{ Transaction tab                                                              } 
{------------------------------------------------------------------------------}

procedure TfrmWISQL.cbAutoStartClick(Sender: TObject);
begin
  if RegDB = nil then IB_Transaction.AutoStart := cbAutoStart.Checked;
end;

procedure TfrmWISQL.cbAutoCommitClick(Sender: TObject);
begin
  IB_Transaction.AutoCommit := cbAutoCommit.Checked;
end;

procedure TfrmWISQL.IB_TransactionSourceBeforeStart(
  Sender: TIB_TransactionLink; T: TIB_Transaction);
begin
  with T do begin
    AutoStart := cbAutoStart.Checked; 
    ReadOnly := cbReadOnly.Checked;
    LockWait := cbLockWait.Checked;
    case rgIsolation.ItemIndex of
      0: Isolation := tiConcurrency;
      1: Isolation := tiConsistency;
      2,
      3: Isolation := tiCommitted;
    end;
    RecVersion := rgIsolation.ItemIndex = 2;
  end;
end;

procedure TfrmWISQL.TransactionPropChanged(Sender: TObject);
begin
  with IB_TransactionSource do begin
    if Started then begin
      IB_Transaction.Close;
    end;
  end;
end;

{------------------------------------------------------------------------------}
{   DSQL tab                                                                   }
{------------------------------------------------------------------------------}

procedure TfrmWISQL.stIB_DSQLBeforePrepare(
  Sender: TIB_StatementLink; IB_Statement: TIB_Statement);
begin
  dsqlEdit.SQL.Text := meDSQL.Lines.Text;
end;

procedure TfrmWISQL.meDSQLChange(Sender: TObject);
begin
  dsqlEdit.Prepared := false;
end;

procedure TfrmWISQL.btNewSQLClick(Sender: TObject);
begin
  with dsqlEdit do begin
    SQLHistoryRef := SQLHistoryCount;
    Prepared := false;
  end;
  meDSQL.Lines.Clear;
  pcDSQL.ActivePage := tsDSQLStatement;
  meDSQL.SetFocus;
  UpdateDSQLButtons;
end;

procedure TfrmWISQL.btSQLPreviousClick(Sender: TObject);
begin
  with dsqlEdit do begin
    SQLHistoryRef := SQLHistoryRef - 1;
  end;
  meDSQL.Lines.Text := dsqlEdit.SQL.Text;
  pcDSQL.ActivePage := tsDSQLStatement;
  meDSQL.SetFocus;
  UpdateDSQLButtons;
end;

procedure TfrmWISQL.btSQLNextClick(Sender: TObject);
begin
  with dsqlEdit do begin
    SQLHistoryRef := SQLHistoryRef + 1;
  end;
  meDSQL.Lines.Text := dsqlEdit.SQL.Text;
  pcDSQL.ActivePage := tsDSQLStatement;
  meDSQL.SetFocus;
  UpdateDSQLButtons;
end;

procedure TfrmWISQL.stIB_DSQLAfterUnprepare(
  Sender: TIB_StatementLink; IB_Statement: TIB_Statement);
begin
  UpdateDSQLButtons;
end;

procedure TfrmWISQL.UpdateDSQLButtons;
begin
  with dsqlEdit do begin
    btSQLPrevious.Enabled := ( SQLHistoryCount > 0 ) and ( SQLHistoryRef > 0 );
    btSQLNext.Enabled := ( SQLHistoryCount > SQLHistoryRef + 1 );
  end;
end;

{------------------------------------------------------------------------------}
{   Cursor tab                                                                 }
{------------------------------------------------------------------------------}

procedure TfrmWISQL.stIB_CursorBeforePrepare(
  Sender: TIB_StatementLink; IB_Statement: TIB_Statement);
begin
  crEdit.SQL.Text := meCursor.Lines.Text;
end;

procedure TfrmWISQL.meCursorChange(Sender: TObject);
begin
  crEdit.Prepared := false;
end;

procedure TfrmWISQL.stIB_CursorAfterPrepare(
  Sender: TIB_StatementLink; Statement: TIB_Statement);
begin
  meCursorPlan.Text := crEdit.StatementPlan;
end;

procedure TfrmWISQL.dsIB_CursorStateChanged(
  Sender: TIB_DataSource; AIB_DataSet: TIB_DataSet);
begin
  if ( AIB_DataSet <> nil ) and
     ( AIB_DataSet.State = dsSearch ) then begin
    pcCursor.ActivePage := tsCursorOutput;
  end;
end;

procedure TfrmWISQL.nbNavigationBarBeforeAction(Sender: TObject);
begin
  if nbNavigationBar.FocusedButton = nbLast then begin
    pcCursor.ActivePage := tsCursorOutput;
  end;
end;

{------------------------------------------------------------------------------}
{  Query Forms                                                                 }
{------------------------------------------------------------------------------}

procedure TfrmWISQL.lbQueryFormNamesDblClick(Sender: TObject);
var
  tmpQueryForm: TfrmQuery;
  ii: integer;
begin
  tmpQueryForm := nil;
  for ii := 0 to Screen.FormCOunt - 1 do begin
    if Screen.Forms[ ii ] is TfrmQuery then begin
      with Screen.Forms[ ii ] as TfrmQuery do begin
        with lbQueryFormNames do if QueryForm = Items[ ItemIndex ] then begin
          tmpQueryForm := Screen.Forms[ ii ] as TfrmQuery;
          Break;
        end;
      end;
    end;
  end;
  if tmpQueryForm = nil then begin
    tmpQueryForm := TfrmQuery.Create( Application );
    with tmpQueryForm do begin
      IB_Connection := Self.IB_Connection;
      IB_Transaction := Self.IB_Transaction;
      dsMasterSource.DataSet := crEdit;
      with lbQueryFormNames do begin
        QueryForm := '';
        if ItemIndex >= 0 then begin
          QueryForm := Items[ ItemIndex ];
        end;
        if QueryForm = '' then begin
          QueryForm := 'Default Query';
        end;
      end;
      Caption := QueryForm;
      BaseKey := Self.BaseKey + '\LAYOUTS\' +
                 Self.Layout + '\QUERIES\' + QueryForm;
    end;
  end;
  tmpQueryForm.Show;
end;

procedure TfrmWISQL.btNewQueryFormClick(Sender: TObject);
begin
  with lbQueryFormNames do begin
    if Items.IndexOf( edNewQueryForm.Text ) = -1 then begin
      Items.Insert( 0, edNewQueryForm.Text );
      ItemIndex := 0;
      SubKey := 'Current';
      try
        WriteStrings( 'Query Names', lbQueryFormNames.Items );
      finally
        SubKey := '';
      end;
    end else begin
      ItemIndex := Items.IndexOf( edNewQueryForm.Text );
    end;
  end;
  edNewQueryForm.Text := '';
end;

procedure TfrmWISQL.btRemoveQueryFormClick(Sender: TObject);
var
  tmpQueryForm: TfrmQuery;
  ii: integer;
begin
  tmpQueryForm := nil;
  for ii := 0 to Screen.FormCOunt - 1 do begin
    if Screen.Forms[ ii ] is TfrmQuery then begin
      with Screen.Forms[ ii ] as TfrmQuery do begin
        with lbQueryFormNames do if QueryForm = Items[ ItemIndex ] then begin
          tmpQueryForm := Screen.Forms[ ii ] as TfrmQuery;
          Break;
        end;
      end;
    end;
  end;
  if tmpQueryForm <> nil then begin
    tmpQueryForm.Free;
  end;
  with lbQueryFormNames do begin
    if ( ItemIndex >= 0 ) and ( Items[ ItemIndex ] <> '' ) then begin
      SubKey := '\QUERIES';
      try
        WriteStrings( Items[ ItemIndex ], nil );
      finally
        SubKey := '';
      end;
      Items.Delete( ItemIndex );
      SubKey := 'Current';
      try
        WriteStrings( 'Query Names', lbQueryFormNames.Items );
      finally
        SubKey := '';
      end;
    end;
  end;
end;

{------------------------------------------------------------------------------}

end.

