
{                                                                              }
{ IB_ConnectionSource                                                          }
{                                                                              }

unit
  IB_ConnectionSource;

interface

uses
  Classes, IB_Components;

type
  TIB_ConnectionSource = class(TIB_ConnectionLink)
  private
    FBeforeAssignment: TIB_ConnectionLinkEvent;
    FAfterAssignment: TIB_ConnectionLinkEvent;
    FBeforeExecDDL: TIB_ConnectionLinkEvent;
    FAfterExecDDL: TIB_ConnectionLinkEvent;
    FBeforeConnect: TIB_ConnectionLinkEvent;
    FAfterConnect: TIB_ConnectionLinkEvent;
    FBeforeDisconnect: TIB_ConnectionLinkEvent;
    FAfterDisconnect: TIB_ConnectionLinkEvent;
    FBeforeCreateDatabase: TIB_ConnectionLinkEvent;
    FAfterCreateDatabase: TIB_ConnectionLinkEvent;
    FBeforeDropDatabase: TIB_ConnectionLinkEvent;
    FAfterDropDatabase: TIB_ConnectionLinkEvent;
    FOnConnectedChanged: TIB_ConnectionLinkEvent;
  public
    procedure ProcessEvent( AEvent: TIB_ConnectionEventType ); override;
  published
    property BeforeAssignment: TIB_ConnectionLinkEvent read FBeforeAssignment
                                                       write FBeforeAssignment;
    property AfterAssignment: TIB_ConnectionLinkEvent read FAfterAssignment
                                                      write FAfterAssignment;
    property BeforeExecDDL: TIB_ConnectionLinkEvent read FBeforeExecDDL
                                                    write FBeforeExecDDL;
    property AfterExecDDL: TIB_ConnectionLinkEvent read FAfterExecDDL
                                                   write FAfterExecDDL;
    property BeforeConnect: TIB_ConnectionLinkEvent read FBeforeConnect
                                                    write FBeforeConnect;
    property AfterConnect: TIB_ConnectionLinkEvent read FAfterConnect
                                                   write FAfterConnect;
    property BeforeDisconnect: TIB_ConnectionLinkEvent read FBeforeDisconnect
                                                       write FBeforeDisconnect;
    property AfterDisconnect: TIB_ConnectionLinkEvent read FAfterDisconnect
                                                      write FAfterDisconnect;
    property BeforeCreateDatabase: TIB_ConnectionLinkEvent
        read FBeforeCreateDatabase
       write FBeforeCreateDatabase;
    property AfterCreateDatabase: TIB_ConnectionLinkEvent
        read FAfterCreateDatabase
       write FAfterCreateDatabase;
    property BeforeDropDatabase: TIB_ConnectionLinkEvent
        read FBeforeDropDatabase
       write FBeforeDropDatabase;
    property AfterDropDatabase: TIB_ConnectionLinkEvent
        read FAfterDropDatabase
       write FAfterDropDatabase;
    property OnConnectedChanged: TIB_ConnectionLinkEvent
        read FOnConnectedChanged
       write FOnConnectedChanged;
  end;

implementation

procedure TIB_ConnectionSource.ProcessEvent( AEvent: TIB_ConnectionEventType );
begin
  if not ( csDestroying in ComponentState ) then case AEvent of
    cetBeforeAssignment:
      if Assigned(BeforeAssignment) then
        BeforeAssignment(Self, IB_Connection);
    cetAfterAssignment:
      if Assigned(AfterAssignment) then
        AfterAssignment( Self, IB_Connection );
    cetBeforeExecDDL:
      if Assigned ( FBeforeExecDDL ) then
        FBeforeExecDDL( Self, IB_Connection );
    cetAfterExecDDL:
      if Assigned ( FAfterExecDDL ) then
        FAfterExecDDL( Self, IB_Connection );
    cetConnectedChanged:
      if Assigned ( FOnConnectedChanged ) then
        FOnConnectedChanged( Self, IB_Connection );
    cetBeforeCreateDatabase:
      if Assigned ( FBeforeCreateDatabase ) then
        FBeforeCreateDatabase( Self, IB_Connection );
    cetBeforeConnect:
      if Assigned ( FBeforeConnect ) then
        FBeforeConnect( Self, IB_Connection );
    cetAfterConnect:
      if Assigned ( FAfterConnect ) then
        FAfterConnect( Self, IB_Connection );
    cetBeforeDisconnect:
      if Assigned ( FBeforeDisconnect ) then
        FBeforeDisconnect( Self, IB_Connection );
    cetAfterDisconnect:
      if Assigned ( FAfterDisconnect ) then
        FAfterDisconnect( Self, IB_Connection );
    cetAfterCreateDatabase:
      if Assigned ( FAfterCreateDatabase ) then
        FAfterCreateDatabase( Self, IB_Connection );
    cetBeforeDropDatabase:
      if Assigned ( FBeforeDropDatabase ) then
        FBeforeDropDatabase( Self, IB_Connection );
    cetAfterDropDatabase:
      if Assigned ( FAfterDropDatabase ) then
        FAfterDropDatabase( Self, IB_Connection );
  end;
end;

end.
