
{                                                                              }
{ IB_CONSTANTS                                                                 }
{                                                                              }

unit
  IB_Constants;

interface

const
  IB_GDS32 = 'gds32.dll';

// Version information
  IB_VERSION_MAJOR = '2';
  IB_VERSION_MINOR = '4';
  IB_VERSION_BUILD = '174';

// Internal settings
  IB_RDB    = 'RDB$';
  IB_DB_KEY = 'DB_KEY';

// Parameter binding syntax
  IB_BINDLINK      = 'BIND_';
  IB_MASTERLINK    = 'LINK_';
  IB_PARAMETER     = 'PARAM_';
  IB_QBE_PARAMETER = 'QBE_';

// General flags
  IB_TRUE  = 'TRUE';
  IB_FALSE = 'FALSE';

// Connection parameter names.
  IB_USER_NAME          = 'USER NAME';
  IB_PASSWORD           = 'PASSWORD';
  IB_SERVER             = 'SERVER';
  IB_PATH               = 'PATH';
  IB_LICENSE            = 'LICENSE';
  IB_SYSDBA             = 'SYSDBA';
  IB_ENCRYPT_KEY        = 'ENCRYPT KEY';
  IB_CHARACTER_SET      = 'CHARACTER SET';
  IB_MESSAGE_FILE       = 'MESSAGE FILE';
  IB_SHADOW_FILE        = 'SHADOW FILE';
  IB_FORCED_WRITES      = 'FORCED WRITES';
  IB_BUFFERS            = 'BUFFERS';
  IB_PAGE_SIZE          = 'PAGE SIZE';
  IB_RESERVE_PAGE_SPACE = 'RESERVE PAGE SPACE';
  IB_PROTOCOL           = 'PROTOCOL';
  IB_DB_KEY_SCOPE       = 'DB_KEY SCOPE';

// Connection parameter values.
  IB_PROTOCOL_LOCAL    = 'LOCAL';
  IB_PROTOCOL_NETBEUI  = 'NETBEUI';
  IB_PROTOCOL_TCP_IP   = 'TCP/IP';
  IB_PROTOCOL_NOVELL   = 'NOVELL';
  IB_DB_KEY_SCOPE_CONN = 'CONNECTION';
  IB_DB_KEY_SCOPE_TRAN = 'TRANSACTION';

// Used in column object creation for 53bit integer based numeric objects.
  IB_NOROUNDERR = 'NOROUNDERR';
  IB_CURR       = 'CURR';
  IB_COMP       = 'COMP';

// Used for searching
  IB_NOCASE     = 'NOCASE';     // Flag to set a case insensitive search field.
  IB_NOTRAILING = 'NOTRAILING'; // Flag to force LIKE search with % at end.

// Used by the SeachPanel
  IB_UPCASE   = 'UPCASE';
  IB_LOWCASE  = 'LOWCASE';
  IB_NOINSERT = 'NOINSERT';
  IB_NOEDIT   = 'NOEDIT';
  IB_NOSEARCH = 'NOSEARCH';

{ Error constants for IB_Connection, IB_Trannsaction, IB_Statement }

  E_CONNECTED        = 'Connection has already been established.';
  E_NOT_CONNECTED    = 'Connection has not been established.';

  E_NO_TRANS_STARTED = 'Transaction has not been started.';
  E_TRANS_STARTED    = 'Transaction has already been started.';
  E_NO_CONNECTIONS   = 'Transaction has no connections.';
  E_NOT_ENOUGH_CONN  = 'Transaction is missing one or more connections.';
  E_CONN_LOADING     = 'Warning: Connection is still loading.';
  E_TRANS_CONN_SESS  = 'Connections must all be in the same IB_Session.';
  E_ALLOCATED        = 'Statement has already been allocated.';
  E_NOT_ALLOCATED    = 'Statement has not been allocated.';
  E_PREPARED         = 'Statement has already been prepared.';
  E_NOT_PREPARED     = 'Statement has not been prepared.';
  E_OPENED           = 'Statement has already been opened.';
  E_NOT_OPENED       = 'Statement has not been opened.';
  E_CANT_DELETE      = 'Current record in the cursor cannot be deleted.';

  E_NO_CONNECTION    = 'Statement must have an IB_Connection assigned.';
  E_CONNECT_FAILED   = 'Unable to open IB_Connection.';
  E_NO_TRANSACTION   = 'Statement must have an IB_Transaction assigned.';
  E_START_FAILED     = 'Unable to start a transaction.';

  E_AT_END_OF_FILE    = 'At end of file';
  E_AT_END_OF_CURSOR  = 'At end of cursor';
  E_AT_END_OF_BUFFER  = 'At end of buffer';
  E_AT_END_OF_DATASET = 'At end of dataset';
  
  E_BAD_SQL_INF_LEN  = 'Unanticipated length in isc_dsql_sql_info.';
  E_BAD_SQL_INF_DATA = 'Invalid data returned from isc_dsql_sql_info.';

  E_CURSOR_NAME_LOCK = 'Cannot change cursor name while active.';
  E_CURSOR_UNI       = 'IB_CURSOR is unidirectional only.';

  E_UNSUPPORTED_COLUMN_TYPE = 'Unsupported Column type: %f';

  E_FIELDNO_NOT_FOUND = 'FieldNo: %f not found.';
  E_FIELDNAME_NOT_FOUND = 'FieldName: %s not found.';

  E_INVALID_FOCUS_RELATION_NO = 'Invalid Focused Relation No: %f';
  E_INVALID_FOCUS_RELATION_NAME = 'Invalid Focused Relation Name: %s';

  E_INVALID_QBE_IN = 'IN( <val> [ , <val> ... ] ) syntax error';
  E_INVALID_QBE_BETWEEN = 'BETWEEN <val> AND <val> syntax error';
  
  E_UNABLE_TO_LOCATE_DLL_IMPORT = 'Unable to locate DLL import %s';

  E_SESSION_ALREADY_ATTACHED = 'Session is already attached';
  E_SESSION_ALREADY_DETACHED = 'Session is already deached';

  E_UNABLE_TO_LOAD_SESSION = 'Unable to load $s';

  E_INVALID_SQL_KEY_FIELDS = 'Invalid SQLKeyFields property';
  E_GET_CURSOR_ERROR = 'Cannot open curosr without key data';
  E_SCROLL_ERROR = 'Record key was lost.'#10#13'Failed to open cursor';
  E_INVALID_BUFFER_ROW_NUM = 'Invalid BufferRowNum before beginning';
  E_BLANK_STATEMENT = 'Cannot Prepare a blank statement';

  E_UNKNOWN_STATEMENT = 'Attempt to execute an unknown statement';

  E_CIRCULAR_REFERENCE = 'Circular reference not allowed';

  E_CANT_CHG_WITH_CONN  = 'Cannot change while connected';
  E_LOGIN_FAILED        = 'Login failed';
  E_CANT_GET_CONN_CHR   = 'Cannot get connection characteristics';
  E_CANT_SHARE_DBHANDLE = 'Connections cannot share a db handle';

implementation

end. 
