
{                                                                              }
{ IB_Searchdit                                                                 }
{                                                                              }

unit
  IB_SearchEdit;

interface

uses
  SysUtils, Windows, Messages, Classes, Controls, Forms, Graphics, Menus,
  StdCtrls, ExtCtrls, ComCtrls, Mask, Buttons, Dialogs, Clipbrd,

  IB_Components,
  IB_ParamEdit;

type
  TIB_SearchEdit = class(TIB_CustomParamEdit)
  private
    FIB_DataLink: TIB_DataLink;
    procedure SetDataSource( AValue: TIB_DataSource );
    function GetDataSource: TIB_DataSource;
    procedure AssignmentChanged( Sender: TIB_DataLink;
                                 ADataSource: TIB_DataSource );
    procedure CMEnter(var Message: TCMEnter); message CM_ENTER;
  protected
    procedure SysStateChanged; override;
    procedure ProcessEvent( AEvent: TIB_StatementEventType;
                            Info: longint ); override;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  published
  { New Properties }
    property DataSource: TIB_DataSource read GetDataSource
                                        write SetDataSource;
  { Inherited Properties }
    property AutoSelect;
    property AutoSize;
    property BorderStyle;
    property CharCase;
    property Color;
    property Ctl3D;
    property DragCursor;
    property DragMode;
    property Enabled;
    property Font;
    property MaxLength;
    property ParentColor;
    property ParentCtl3D;
    property ParentFont;
    property ParentShowHint;
    property PasswordChar;
    property PopupMenu;
    property ShowHint;
    property TabOrder;
    property TabStop;
    property Visible;
  { Inherited Events }
    property OnPrepareSQL;
    property OnChange;
    property OnClick;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDrag;
    property OnEnter;
    property OnExit;
    property OnKeyDown;
    property OnKeyPress;
    property OnKeyUp;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnStartDrag;
  end;

implementation

constructor TIB_SearchEdit.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FIB_DataLink := TIB_DataLink.Create( Self );
  FIB_DataLink.AfterAssignment := AssignmentChanged;
end;

destructor TIB_SearchEdit.Destroy;
begin
  DataSource := nil;
  FIB_DataLink.AfterAssignment := nil;
  inherited Destroy;
end;

procedure TIB_SearchEdit.AssignmentChanged( Sender: TIB_DataLink;
                                            ADataSource: TIB_DataSource );
begin
  if ADataSource <> nil then begin
    Statement := ADataSource.DataSet;
  end else begin
    Statement := nil;
  end;
end;

procedure TIB_SearchEdit.SysStateChanged;
var
  NewParamName: string;
begin
  if FIB_DataLink.Prepared then begin
    NewParamName := DataSource.DataSet.SearchingParamName;
  end else begin
    NewParamName := '';
  end;
  if ParamName <> NewParamName then begin
    ParamName := NewParamName;
  end else begin
    inherited SysStateChanged;
  end;
end;

function TIB_SearchEdit.GetDataSource: TIB_DataSource;
begin
  Result := FIB_DataLink.DataSource;
end;

procedure TIB_SearchEdit.SetDataSource(AValue: TIB_DataSource);
begin
  FIB_DataLink.DataSource := AValue;
end;

procedure TIB_SearchEdit.CMEnter(var Message: TCMEnter);
begin
  FIB_DataLink.SetFocus;
  inherited;
end;

procedure TIB_SearchEdit.ProcessEvent( AEvent: TIB_StatementEventType;
                                       Info: longint );
begin
  inherited ProcessEvent( AEvent, Info );
  if AEvent = setSearchingLinkChanged then begin
    SysStateChanged;
  end;
end;

end.
