
{                                                                              }
{ IB_TransactionSource                                                         }
{                                                                              }

unit
  IB_TransactionSource;

interface

uses
  Classes, IB_Components;

type
  TIB_TransactionSource = class( TIB_TransactionLink )
  private
  { Event Storage Fields }
    FBeforeAssignment: TIB_TransactionLinkEvent;
    FAfterAssignment:  TIB_TransactionLinkEvent;
    FBeforeStart:      TIB_TransactionLinkEvent;
    FAfterStart:       TIB_TransactionLinkEvent;
    FBeforeSavePoint:  TIB_TransactionLinkEvent;
    FAfterSavePoint:   TIB_TransactionLinkEvent;
    FBeforeCommit:     TIB_TransactionLinkEvent;
    FAfterCommit:      TIB_TransactionLinkEvent;
    FBeforeRollback:   TIB_TransactionLinkEvent;
    FAfterRollback:    TIB_TransactionLinkEvent;
    FBeforeEnd:        TIB_TransactionLinkEvent;
    FAfterEnd:         TIB_TransactionLinkEvent;
    FOnStatusChanged:  TIB_TransactionLinkEvent;
  public
  { Inherited methods }
    procedure ProcessEvent( AEvent: TIB_TransactionEventType ); override;
  published
  { Events }
    property BeforeAssignment: TIB_TransactionLinkEvent read FBeforeAssignment
                                                        write FBeforeAssignment;
    property AfterAssignment:  TIB_TransactionLinkEvent read FAfterAssignment
                                                        write FAfterAssignment;
    property BeforeStart:      TIB_TransactionLinkEvent read FBeforeStart
                                                        write FBeforeStart;
    property AfterStart:       TIB_TransactionLinkEvent read FAfterStart
                                                        write FAfterStart;
    property BeforeSavePoint:  TIB_TransactionLinkEvent read FBeforeSavePoint
                                                        write FBeforeSavePoint;
    property AfterSavePoint:   TIB_TransactionLinkEvent read FAfterSavePoint
                                                        write FAfterSavePoint;
    property BeforeCommit:     TIB_TransactionLinkEvent read FBeforeCommit
                                                        write FBeforeCommit;
    property AfterCommit:      TIB_TransactionLinkEvent read FAfterCommit
                                                        write FAfterCommit;
    property BeforeRollback:   TIB_TransactionLinkEvent read FBeforeRollback
                                                        write FBeforeRollback;
    property AfterRollback:    TIB_TransactionLinkEvent read FAfterRollback
                                                        write FAfterRollback;
    property BeforeEnd:        TIB_TransactionLinkEvent read FBeforeEnd
                                                        write FBeforeEnd;
    property AfterEnd:         TIB_TransactionLinkEvent read FAfterEnd
                                                        write FAfterEnd;
    property OnStatusChanged:  TIB_TransactionLinkEvent read FOnStatusChanged
                                                        write FOnStatusChanged;
  end;

implementation

procedure TIB_TransactionSource.ProcessEvent(AEvent: TIB_TransactionEventType);
begin
  inherited ProcessEvent( AEvent );
  if not ( csLoading in ComponentState ) and
     not ( csDestroying in ComponentState ) then case AEvent of
    tetBeforeAssignment:
      if Assigned(BeforeAssignment) then BeforeAssignment(Self, IB_Transaction);
    tetAfterAssignment:
      if Assigned(AfterAssignment) then AfterAssignment( Self, IB_Transaction );
    tetBeforeStart:
      if Assigned( BeforeStart ) then BeforeStart( Self, IB_Transaction );
    tetAfterStart:
      if Assigned( AfterStart ) then AfterStart( Self, IB_Transaction );
    tetBeforeCommit:
      if Assigned( BeforeCommit ) then BeforeCommit( Self, IB_Transaction );
    tetAfterCommit:
      if Assigned( AfterCommit ) then AfterCommit( Self, IB_Transaction );
    tetBeforeSavepoint:
      if Assigned(BeforeSavepoint) then BeforeSavepoint( Self, IB_Transaction );
    tetAfterSavepoint:
      if Assigned( AfterSavepoint ) then AfterSavepoint( Self, IB_Transaction );
    tetBeforeRollback:
      if Assigned( BeforeRollback ) then BeforeRollback( Self, IB_Transaction );
    tetAfterRollback:
      if Assigned( AfterRollback ) then AfterRollback( Self, IB_Transaction );
    tetBeforeEnd:
      if Assigned( BeforeEnd ) then BeforeEnd( Self, IB_Transaction );
    tetAfterEnd:
      if Assigned( AfterEnd ) then AfterEnd( Self, IB_Transaction );
    tetOnStatusChanged:
      if Assigned(OnStatusChanged) then OnStatusChanged( Self, IB_Transaction );
  end;
end;

end.
