// INT_IBC_Text 

constructor TIB_Text.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  ControlStyle := ControlStyle + [csReplicatable];
  AutoSize := false;
  ShowAccelChar := false;
  FIB_FieldDataLink := TIB_FieldDataLink.Create( Self );
  FIB_FieldDataLink.OnDataChange := DataChange;
end;

destructor TIB_Text.Destroy;
begin
  DataSource := nil;
  with FIB_FieldDataLink do begin
    OnDataChange := nil;
  end;
  inherited Destroy;
end;

procedure TIB_Text.DataChange( Sender: TIB_DataLink;
                               IB_DataSource: TIB_DataSource;
                               IB_Field: TIB_Column );
begin
  with FIB_FieldDataLink do begin
    Alignment := FieldAlignment;
    Caption := FieldText;
  end;
end;

function TIB_Text.GetLabelText: string;
begin
  if csPaintCopy in ControlState then begin
    Result := FIB_FieldDataLink.FieldText;
  end else begin
    Result := Caption;
  end;
end;

function TIB_Text.GetDataSource: TIB_DataSource;
begin
  Result := FIB_FieldDataLink.DataSource;
end;
procedure TIB_Text.SetDataSource(Value: TIB_DataSource);
begin
  FIB_FieldDataLink.DataSource := Value;
end;
function TIB_Text.GetDataField: string;
begin
  Result := FIB_FieldDataLink.FieldName;
end;
procedure TIB_Text.SetDataField( const Value: string );
begin
  FIB_FieldDataLink.FieldName := Value;
end;
function TIB_Text.GetField: TIB_Column;
begin
  Result := FIB_FieldDataLink.Field;
end;

