{ TIB_CheckBox }

  TIB_CheckBox = class( TCustomCheckBox )
  private
    FIB_FieldDataLink: TIB_FieldDataLink;
    FValueChecked: string;
    FValueUncheck: string;
    FPaintControl: TPaintControl;
    FBorderStyle: TBorderStyle;
    procedure StateChanged( Sender: TIB_DataLink;
                            IB_DataSource: TIB_DataSource );
    procedure DataChange( Sender: TIB_DataLink;
                          IB_DataSource: TIB_DataSource;
                          IB_Field: TIB_Column );
    procedure UpdateData( Sender: TIB_DataLink;
                          IB_DataSource: TIB_DataSource;
                          IB_Field: TIB_Column );
    procedure SetSearchBuffer( AValue: string );
    function GetSearchBuffer: string;
    procedure SetDataField( const AValue: string );
    function GetDataField: string;
    procedure SetDataSource( AValue: TIB_DataSource );
    function GetDataSource: TIB_DataSource;
    function GetField: TIB_Column;
    procedure SetReadOnly(Value: Boolean);
    procedure SetPreventEditing( Value: Boolean );
    procedure SetPreventInserting( Value: Boolean );
    procedure SetPreventSearching( Value: Boolean );
    function GetReadOnly: Boolean;
    function GetPreventEditing: Boolean;
    function GetPreventInserting: Boolean;
    function GetPreventSearching: Boolean;
    procedure SetOnPrepareSQL( AValue: TIB_DataLinkEvent); virtual;
    function GetOnPrepareSQL: TIB_DataLinkEvent; virtual;
    procedure SetBorderStyle(Value: TBorderStyle);
    function GetFieldState: TCheckBoxState; virtual;
    procedure SetValueCheck(const Value: string);
    procedure SetValueUncheck(const Value: string);
    procedure WMPaint(var Message: TWMPaint); message WM_PAINT;
    procedure CMEnter(var Message: TCMEnter); message CM_ENTER;
    procedure CMExit(var Message: TCMExit); message CM_EXIT;
  protected
    procedure CreateParams(var Params: TCreateParams); override;
    procedure Loaded; override;
    procedure Toggle; override;
    procedure KeyPress(var Key: Char); override;
    procedure WndProc(var Message: TMessage); override;
    procedure SysDataChange; virtual;
    procedure SysStateChanged; virtual;
    procedure SysUpdateData; virtual;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    property Checked;
    property State;
    property SearchBuffer: string read GetSearchBuffer write SetSearchBuffer;
    property Field: TIB_Column read GetField;
  published
    property Alignment;
    property AllowGrayed;
    property Caption;
    property Color;
    property Ctl3D;
    property DragCursor;
    property DragMode;
    property Enabled;
    property Font;
    property ParentColor;
    property ParentCtl3D;
    property ParentFont;
    property ParentShowHint;
    property PopupMenu;
    property ShowHint;
    property TabOrder;
    property TabStop;
    property Visible;

    property ValueChecked: string read FValueChecked write SetValueCheck;
    property ValueUnchecked: string read FValueUncheck write SetValueUncheck;

    property BorderStyle: TBorderStyle read FBorderStyle
                                       write SetBorderStyle
                                       default bsSingle;
    property DataField: string read GetDataField
                               write SetDataField;
    property DataSource: TIB_DataSource read GetDataSource
                                        write SetDataSource;
    property ReadOnly: boolean read GetReadOnly
                               write SetReadOnly
                               default false;
    property PreventEditing: boolean read GetPreventEditing
                                     write SetPreventEditing
                                     default false;
    property PreventInserting: boolean read GetPreventInserting
                                       write SetPreventInserting
                                       default false;
    property PreventSearching: boolean read GetPreventSearching
                                       write SetPreventSearching
                                       default false;

    property OnPrepareSQL: TIB_DataLinkEvent read GetOnPrepareSQL
                                             write SetOnPrepareSQL;
    property OnClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDrag;
    property OnEnter;
    property OnExit;
    property OnKeyDown;
    property OnKeyPress;
    property OnKeyUp;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnStartDrag;
  end;
  
// IMP_IBC_CHECKBOX