
{ TIB_Image }

  TIB_Image = class( TCustomControl )
  private
    FIB_FieldDataLink: TIB_FieldDataLink;
    FAutoSize: Boolean;
    FPicture: TPicture;
    FBorderStyle: TBorderStyle;
    FAutoDisplay: boolean;
    FStretch: boolean;
    FCenter: boolean;
    FKeepScale: boolean;
    FPictureLoaded: boolean;
    FQuickDraw: boolean;
    FBlobIDLoaded: isc_quad;
    FIsUpdating: boolean;
    FIgnorePictureChange: boolean;
    procedure IB_StateChanged( Sender: TIB_DataLink;
                               DataSource: TIB_DataSource );
    procedure IB_DataChange( Sender: TIB_DataLink;
                             DataSource: TIB_DataSource;
                             Field: TIB_Column );
    procedure IB_UpdateData( Sender: TIB_DataLink;
                             DataSource: TIB_DataSource;
                             Field: TIB_Column );
    procedure SetAutoSize(Value: Boolean);
    function GetSearchBuffer: string;
    procedure SetSearchBuffer( AValue: string );
    procedure SetDataField( const AValue: string );
    procedure SetDataSource( AValue: TIB_DataSource );
    function GetReadOnly: Boolean;
    function GetPreventEditing: Boolean;
    function GetPreventInserting: Boolean;
    procedure SetReadOnly(Value: Boolean);
    procedure SetPreventEditing( Value: Boolean );
    procedure SetPreventInserting( Value: Boolean );
    function GetDataField: string;
    function GetDataSource: TIB_DataSource;
    function GetField: TIB_Column;
    procedure PictureChanged(Sender: TObject);
    procedure SetAutoDisplay(Value: Boolean);
    procedure SetBorderStyle(Value: TBorderStyle);
    procedure SetCenter(Value: Boolean);
    procedure SetPicture(Value: TPicture);
    procedure SetStretch(Value: Boolean);
    procedure SetKeepScale(Value: Boolean);
    procedure CMEnter(var Message: TCMEnter); message CM_ENTER;
    procedure CMExit(var Message: TCMExit); message CM_EXIT;
    procedure WMLButtonDown(var Message: TWMLButtonDown); message WM_LBUTTONDOWN;
    procedure WMLButtonDblClk(var Message: TWMLButtonDblClk); message WM_LBUTTONDBLCLK;
    procedure WMCut(var Message: TMessage); message WM_CUT;
    procedure WMCopy(var Message: TMessage); message WM_COPY;
    procedure WMPaste(var Message: TMessage); message WM_PASTE;
    procedure CMTextChanged(var Message: TMessage); message CM_TEXTCHANGED;
  protected
    procedure CreateParams(var Params: TCreateParams); override;
    function GetPalette: HPALETTE; override;
    procedure KeyDown(var Key: Word; Shift: TShiftState); override;
    procedure KeyPress(var Key: Char); override;
    procedure Paint; override;
    procedure Loaded; override;
    procedure SysDataChange;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure CopyToClipboard;
    procedure CutToClipboard;
    procedure LoadPicture;
    procedure PasteFromClipboard;
    property Field: TIB_Column read GetField;
    property Picture: TPicture read FPicture write SetPicture;
    property SearchBuffer: string read GetSearchBuffer write SetSearchBuffer;
  published
    property Align;
    property Color;
    property Ctl3D;
    property DragCursor;
    property DragMode;
    property Enabled;
    property Font;
    property ParentColor default false;
    property ParentCtl3D;
    property ParentFont;
    property ParentShowHint;
    property PopupMenu;
    property ShowHint;
    property TabOrder;
    property TabStop default true;
    property Visible;

    property AutoDisplay: Boolean read FAutoDisplay
                                  write SetAutoDisplay
                                  default True;
    property AutoSize: Boolean read FAutoSize write SetAutoSize default False;
    property BorderStyle: TBorderStyle read FBorderStyle
                                       write SetBorderStyle
                                       default bsSingle;
    property Center: Boolean read FCenter write SetCenter default true;
    property DataField: string read GetDataField write SetDataField;
    property DataSource: TIB_DataSource read GetDataSource write SetDataSource;
    property PreventEditing: boolean read GetPreventEditing
                                     write SetPreventEditing
                                     default false;
    property PreventInserting: boolean read GetPreventInserting
                                       write SetPreventInserting
                                       default false;
    property QuickDraw: Boolean read FQuickDraw write FQuickDraw default true;
    property ReadOnly: boolean read GetReadOnly write SetReadOnly default false;
    property Stretch: Boolean read FStretch write SetStretch default false;
    property KeepScale: Boolean read FKeepScale write SetKeepScale default true;

    property OnClick;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDrag;
    property OnEnter;
    property OnExit;
    property OnKeyDown;
    property OnKeyPress;
    property OnKeyUp;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnStartDrag;
  end;

// IMP_IBC_Image