
{ TIB_RadioGroup }

  TIB_RadioGroup = class(TCustomGroupBox)
  private
    FButtons: TList;
    FItems: TStrings;
    FItemIndex: Integer;
    FColumns: Integer;
    FReading: Boolean;
    FEditing: Boolean;
    FTabStop: boolean;
    procedure SetTabStop( AValue: boolean ); virtual;
    procedure ArrangeButtons;
    procedure ButtonClick(Sender: TObject);
    procedure ItemsChange(Sender: TObject);
    procedure SetButtonCount(Value: Integer);
    procedure SetColumns(Value: Integer);
    procedure SetItemIndex(Value: Integer);
    procedure UpdateButtons;
    procedure CMEnabledChanged(var Message: TMessage);message CM_ENABLEDCHANGED;
    procedure CMFontChanged(var Message: TMessage); message CM_FONTCHANGED;
    procedure WMSize(var Message: TWMSize); message WM_SIZE;
  private
    FIB_FieldDataLink: TIB_FieldDataLink;
    FValue: string;
    FValues: TStrings;
    FInSetValue: Boolean;
    FOnChange: TNotifyEvent;
    FBorderStyle: TBorderStyle;
    procedure StateChanged( Sender: TIB_DataLink;
                            IB_DataSource: TIB_DataSource );
    procedure DataChange( Sender: TIB_DataLink;
                          IB_DataSource: TIB_DataSource;
                          IB_Field: TIB_Column );
    procedure UpdateData( Sender: TIB_DataLink;
                          IB_DataSource: TIB_DataSource;
                          IB_Field: TIB_Column );
    procedure SetSearchBuffer( AValue: string );
    function GetSearchBuffer: string;
    procedure SetDataField( const AValue: string );
    function GetDataField: string;
    procedure SetDataSource( AValue: TIB_DataSource );
    function GetDataSource: TIB_DataSource;
    function GetField: TIB_Column;
    procedure SetReadOnly(Value: Boolean);
    procedure SetPreventEditing( Value: Boolean );
    procedure SetPreventInserting( Value: Boolean );
    procedure SetPreventSearching( Value: Boolean );
    function GetReadOnly: Boolean;
    function GetPreventEditing: Boolean;
    function GetPreventInserting: Boolean;
    function GetPreventSearching: Boolean;
    procedure SetOnPrepareSQL( AValue: TIB_DataLinkEvent); virtual;
    function GetOnPrepareSQL: TIB_DataLinkEvent; virtual;
    procedure SetBorderStyle(Value: TBorderStyle);
    function GetButtonValue(Index: Integer): string;
    procedure SetValue(const Value: string);
    procedure SetItems(Value: TStrings);
    procedure SetValues(Value: TStrings);
    procedure CMEnter( var Message: TCMEnter ); message CM_ENTER;
    procedure CMExit( var Message: TCMExit ); message CM_EXIT;
  protected
    procedure ReadState(Reader: TReader); override;
{$IFNDEF VER100}
    procedure GetChildren(Proc: TGetChildProc ); override;
{$ELSE}
    procedure GetChildren(Proc: TGetChildProc; Root: TComponent); override;
{$ENDIF}
    procedure Loaded; override;
    procedure CreateParams(var Params: TCreateParams); override;
    procedure Paint; override;
    procedure Change; dynamic;
    procedure Click; override;
    procedure KeyPress(var Key: Char); override;
    function CanModify: Boolean; virtual;
    property DataLink: TIB_FieldDataLink read FIB_FieldDataLink;
    procedure SysDataChange; virtual;
    procedure SysStateChanged; virtual;
    procedure SysUpdateData; virtual;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    property Field: TIB_Column read GetField;
    property ItemIndex: Integer read FItemIndex write SetItemIndex default -1;
    property Value: string read FValue write SetValue;
    property SearchBuffer: string read GetSearchBuffer write SetSearchBuffer;
  published
    property Align;
    property Color;
    property Ctl3D;
    property DragCursor;
    property DragMode;
    property Enabled;
    property Font;
    property ParentColor;
    property ParentCtl3D;
    property ParentFont;
    property ParentShowHint;
    property PopupMenu;
    property ShowHint;
    property TabOrder;
    property Visible;

    property Columns: Integer read FColumns write SetColumns default 1;
    property DataField: string read GetDataField
                               write SetDataField;
    property DataSource: TIB_DataSource read GetDataSource
                                        write SetDataSource;
    property Items: TStrings read FItems write SetItems;
    property TabStop read FTabStop write SetTabStop;
    property Values: TStrings read FValues write SetValues;
    property ReadOnly: boolean read GetReadOnly
                               write SetReadOnly
                               default false;
    property PreventEditing: boolean read GetPreventEditing
                                      write SetPreventEditing
                                      default false;
    property PreventInserting: boolean read GetPreventInserting
                                       write SetPreventInserting
                                       default false;
    property PreventSearching: boolean read GetPreventSearching
                                       write SetPreventSearching
                                       default false;
    property BorderStyle: TBorderStyle read FBorderStyle
                                       write SetBorderStyle
                                       default bsSingle;

    property OnPrepareSQL: TIB_DataLinkEvent read GetOnPrepareSQL
                                             write SetOnPrepareSQL;

    property OnChange: TNotifyEvent read FOnChange write FOnChange;
    property OnClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDrag;
    property OnEnter;
    property OnExit;
    property OnStartDrag;
  end;

  TCustomRadioGroupHack = class(TCustomGroupBox)
  private
    FButtons: TList;
    FItems: TStrings;
    FItemIndex: Integer;
    FColumns: Integer;
    FReading: Boolean;
    FEditing: Boolean;
  end;

// IMP_IBC_RadioGroup
