
{                                                                              }
{ TIB_ColumnBlob                                                               }
{                                                                              }

// I had to grab this out of DBTables.PAS from the VCL.
// I modified it so that there wouldn't be a conflict.
  TIB_GraphicHeader = record
    Count: Word;                { Fixed at 1 }
    HType: Word;                { Fixed at $0100 }
    Size: Longint;              { Size not including header }
  end;

  TIB_ColumnBlob = class( TIB_Column )
  private
  { General storage }
    FIB_Session: TIB_Session;
    FBlob_Desc: isc_blob_desc;
    FBlob_Handle: isc_blob_handle;
    FBlob_Parameter_Block: array [0..255] of char;
    FTemp_ID: isc_quad;
    FSegmentBufferSize: short;
    FValidSegmentSize: short;
    FSegmentBuffer: pointer;
    FNumOfSegments: longint;    // total number of segments.
    FMaxSegmentSize: longint;   // Size, in bytes, of the longest segment.
    FTotalSize: longint;        // total size, in bytes, of BLOB.
    FBlobType: smallint;        // type of BLOB.0 (segmented)1 (reserved)
    FStream: TStream;
    FOldStream: TStream;
  { Inherited Property Access methods }
    function GetIsModified: boolean; override;
    function GetOldAsString: string; override;
    function GetAsString: string; override;
    function GetAsVariant: Variant; override;
    procedure SetAsString( NewValue: string); override;
    function GetAsStream: TStream; override;
    function GetOldAsStream: TStream; override;
    procedure SetAsStream( AStream: TStream ); override;
  { Property Access methods }
    function GetBlob_ID: isc_quad; virtual;
    function GetPBlob_ID: pisc_quad; virtual;
    function GetPBlob_Handle: pisc_blob_handle; virtual;
    function GetPBlob_Desc: pisc_blob_desc; virtual;
    procedure SetSegmentBufferSize( NewSize: short ); virtual;
    function GetSQLTypeSource: string; override;
  protected
  { Abstract Methods }
    procedure SysClearSegments; virtual;
  { Row synchronization methods }
    procedure ClearBuffers; virtual;
    procedure PostBuffers; virtual;
    procedure CancelBuffers; virtual;
    procedure RefreshBuffers( NewRecord: boolean ); virtual;
  { System Methods }
    procedure SysLoad; virtual;
    procedure SysStore; virtual;
    procedure SysCancel; virtual;
  { API calls }
    procedure API_get_segments;
    procedure API_put_segments;
    procedure API_open_blob;
    procedure API_open_blob2;
    procedure API_create_blob2;
    procedure API_blob_default_desc;
    procedure API_blob_gen_bpb;
    procedure API_blob_info;
    procedure API_blob_lookup_desc;
    procedure API_blob_set_desc;
    procedure API_cancel_blob;
    procedure API_close_blob; 
  { Utility methods }
    procedure LoadFromBlob( const ABlob: TIB_ColumnBlob );
    procedure LoadFromBitmap( const ABitmap: TBitmap );
    procedure LoadFromStrings( Const AStrings: TStrings );
    procedure LoadFromFile( const AFileName: string );
    procedure LoadFromStream( const AStream: TStream );
    procedure SaveToBlob( const ABlob: TIB_ColumnBlob );
    procedure SaveToFile( const AFileName: string );
    procedure SaveToStream( const AStream: TStream );
    procedure SaveToBitmap( const ABitmap: TBitmap );
    procedure SaveToStrings( const AStrings: TStrings );
  { Properties }
    property SegmentBufferSize: short read FSegmentBufferSize
                                      write SetSegmentBufferSize;
  public
    constructor Create( AIB_Row: TIB_Row; AIndex: smallint ); override;
    destructor Destroy; override;
  { Methods }
    procedure BeforeChanged( Clear: boolean ); virtual;
    procedure AfterChanged( Reset: boolean ); virtual;
    procedure Load; virtual;
    procedure Store; virtual;
    procedure Clear; override;
    procedure Assign( Source: TObject ); virtual;
    procedure AssignTo( Dest: TObject ); virtual;
  { Properties }
    property IB_Session: TIB_Session read FIB_Session;
    property Blob_ID: isc_quad read GetBlob_ID;
    property Temp_ID: isc_quad read FTemp_ID;
    property PBlob_ID: pisc_quad read GetPBlob_ID;
    property Blob_Handle: isc_blob_handle read FBlob_Handle;
    property PBlob_Handle: pisc_blob_handle read GetPBlob_Handle;
    property Blob_Desc: isc_blob_desc read FBlob_Desc;
    property PBlob_Desc: pisc_blob_desc read GetPBlob_Desc;
    property NumOfSegments: longint read FNumOfSegments;
    property MaxSegmentSize: longint read FMaxSegmentSize;
    property TotalSize: longint read FTotalSize;
    property BlobType: smallint read FBlobType;
  end;

{                                                                              }
{ TIB_ColumnBinary                                                             }
{                                                                              }

  TIB_ColumnBinary = class( TIB_ColumnBlob )
  end;

{                                                                              }
{ TIB_ColumnMemo                                                               }
{                                                                              }

  TIB_ColumnMemo = class( TIB_ColumnBlob )
  public
    constructor Create( AIB_Row: TIB_Row; AFieldNo: smallint ); override;
  end;

  // IMP_IB_ColumnBLOB
