
{                                                                              }
{ TIB_ConnectionLink                                                           }
{                                                                              }

  TIB_ConnectionLinkEvent = procedure( Sender: TIB_ConnectionLink;
                                       AConnection: TIB_Connection) of object;

  TIB_ConnectionLink = class( TIB_Component )
  private
  { Property Storage Fields }
    FIB_Connection: TIB_Connection;
    FReceiveFocus: boolean;
  { Event Storage }
    FOnReceiveFocus: TIB_ConnectionLinkEvent;
  { Property Access Methods }
    function GetConnected: boolean;
    function GetConnectionStatus: TIB_ConnectionStatus;
    procedure SetReceiveFocus( AValue: boolean );
  protected
  { Inherited Methods }
    procedure Loaded; override;
  { System Methods }
    procedure DoReceiveFocus( C: TIB_Connection ); virtual;
    procedure ProcessEvent( AEvent: TIB_ConnectionEventType ); virtual;
  { Property Access Methods }
    procedure SetIB_Connection( AValue: TIB_Connection ); virtual;
  public
  { Inherited Methods }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  { Properties }
    property Connected: boolean read GetConnected;
    property ConnectionStatus: TIB_ConnectionStatus read GetConnectionStatus;
  published
  { Properties }
    property IB_Connection: TIB_Connection read FIB_Connection
                                           write SetIB_Connection;
    property ReceiveFocus: boolean read FReceiveFocus write SetReceiveFocus;
  { Events }
    property OnReceiveFocus: TIB_ConnectionLinkEvent read FOnReceiveFocus
                                                     write FOnReceiveFocus; 
  end; { TIB_ConnectionLink }

  TIB_ConnectionTransactionLink = class( TIB_ConnectionLink )
  private
    FIB_Transaction: TIB_Transaction;
  public
    procedure ProcessEvent( AEvent: TIB_ConnectionEventType ); override;
  end;

  TIB_ConnectionStatementLink = class( TIB_ConnectionLink )
  private
    FStatement: TIB_Statement;
  public
    procedure ProcessEvent( AEvent: TIB_ConnectionEventType ); override;
  end;

// IMP_IB_ConnectionLink
