
{                                                                              }
{ TIB_DATASET                                                                  }
{                                                                              }

  EIB_DataSetError = class( EIB_Error );

  TIB_DataSetEvent = procedure( IB_DataSet: TIB_DataSet ) of object;
  TIB_FetchCallbackStatus = ( csInit, csRefresh, csFinal );
  TIB_FetchCallbackEvent = procedure( IB_DataSet: TIB_DataSet;
                                      Status: TIB_FetchCallbackStatus;
                                      CursorRowNum: longint ) of object;
  TIB_DataSetState = (dsInactive
                     ,dsPrepared
                     ,dsSearch
                     ,dsBrowse
                     ,dsEdit
                     ,dsInsert
                     ,dsDelete
                     );

  TIB_DataSet = class( TIB_Statement )
  private
  { Property Storage Fields }
    FInsertDSQL: TIB_Statement;
    FIB_MasterDataLink: TIB_DataLink;
    FAutoFetchFirst: boolean;
    FDataSourceList: TList;
    FDetailDataSetList: TList;
    FState: TIB_DataSetState;
    FLastRowState: TIB_RowState;
    FFetchCallbackInc: cardinal;
    FFetching: boolean;
    FFetchAborted: boolean;
    FClosePending: boolean;
    FReadOnly: boolean;
    FPreventEditing: boolean;
    FPreventInserting: boolean;
    FPreventDeleting: boolean;
    FPreventSearching: boolean;
    FCursorName: string;
    FCursorEOF: boolean;
    FCursorRowNum: longint;
    FCursorRowCount: longint;
    FCursorRowCountValid: boolean;
    FPessimisticLocking: boolean;
    FIsRowLocked: boolean;
    FIsPosting: boolean;
    FSQLKeyFields: TStrings;
    FSQLJoinLinks: TStrings;
    FSQLSelect: TStrings;
    FSQLFrom: TStrings;
    FSQLWhere: TStrings;
    FSQLGroup: TStrings;
    FSQLHaving: TStrings;
    FSQLUnion: TStrings;
    FSQLPlan: TStrings;
    FSQLOrder: TStrings;
    FOrderingItems: TStrings;
    FOrderingLinks: TStrings;
    FOrderingItemNo: integer;
    FOrderingLink: string;
    FOrderingField: TIB_Column;
    FSettingOrderingLink: boolean;
    FSearchingLinks: TStrings;
    FSearchingLink: string;
    FSearchingParamName: string;
    FSearchingParam: TIB_Column;
    FSettingSearchingLink: boolean;
    FSQLForUpdate: TStrings;
    FMasterLinks: TStrings;
    FMasterSearch: boolean;
    FMasterWhere: string;
    FSQLWhereLow: TStrings;
    FSQLWhereMed: TStrings;
    FSQLWhereHigh: TStrings;
    FSQLWhereParams: TStrings;
    FSQLWhereChanged: boolean;
    FSQLOrderChanged: boolean;
    FColorScheme: boolean;
    FGetDefaults: boolean;
    FGeneratorLinks: TStrings;
    FMasterSearchWasActive: boolean;
    FMasterDataChangeWasActive: boolean;
  { Fetch callback dialog }
    dlgCancelQuery: TForm;
  { Optimization/System Flags }
    flag_open_after_load: boolean;
    flag_junk_value: integer;
  { Event Storage Fields }
    FBeforeOpen: TIB_DataSetEvent;
    FAfterOpen: TIB_DataSetEvent;
    FBeforeClose: TIB_DataSetEvent;
    FAfterClose: TIB_DataSetEvent;
    FBeforeSearch: TIB_DataSetEvent;
    FAfterSearch: TIB_DataSetEvent;
    FBeforeEdit: TIB_DataSetEvent;
    FAfterEdit: TIB_DataSetEvent;
    FBeforeInsert: TIB_DataSetEvent;
    FAfterInsert: TIB_DataSetEvent;
    FBeforeDelete: TIB_DataSetEvent;
    FAfterDelete: TIB_DataSetEvent;
    FBeforeCancel: TIB_DataSetEvent;
    FAfterCancel: TIB_DataSetEvent;
    FBeforePost: TIB_DataSetEvent;
    FAfterPost: TIB_DataSetEvent;
    FOnFetchCallback: TIB_FetchCallbackEvent;
    FAfterFetchRow: TIB_DataSetEvent;
    FAfterFetchEof: TIB_DataSetEvent;
    function GetHintEdit: string;
    function GetHintInsert: string;
    function GetHintDelete: string;
    function GetHintPost: string;
    function GetHintCancel: string;
    function GetHintFirst: string;
    function GetHintLast: string;
    function GetHintNext: string;
    function GetHintPrior: string;
    function GetHintSearch: string;
    function GetHintCount: string;
    function GetHintOrder: string;
    procedure SetHintEdit( AValue: string );
    procedure SetHintInsert( AValue: string );
    procedure SetHintDelete( AValue: string );
    procedure SetHintPost( AValue: string );
    procedure SetHintCancel( AValue: string );
    procedure SetHintFirst( AValue: string );
    procedure SetHintLast( AValue: string );
    procedure SetHintNext( AValue: string );
    procedure SetHintPrior( AValue: string );
    procedure SetHintSearch( AValue: string );
    procedure SetHintCount( AValue: string );
    procedure SetHintOrder( AValue: string );
    procedure SetSQLKeyFields( ASQLKeyFields: TStrings );
    procedure SetSQLJoinLinks( ASQLJoinLinks: TStrings );
    function GetMasterLinkCount: integer;
    procedure SetMasterLinks( Value: TStrings );
    procedure SetOrderingItems( Value: TStrings );
    procedure SetOrderingLinks( Value: TStrings );
    procedure SetSearchingLinks( Value: TStrings );
    function GetGeneratorLinks: TStrings;
    procedure SetGeneratorLinks( Value: TStrings );
    function GetMasterLink( DetailLink: string ): string;
    procedure SetMasterLink( DetailLink: string; NewMasterLink: string);
    function GetDetailLink( Index: integer ): string;
    procedure SetDetailLink( Index: integer; NewDetailLink: string);
    function GetMasterDataSet: TIB_DataSet;
    function GetMasterRelation( LinkNo: integer ): string;
    function GetMasterFieldName( LinkNo: integer ): string;
    function GetDetailRelation( LinkNo: integer ): string;
    function GetDetailFieldName( LinkNo: integer ): string;
    function GetSQLSection( Index: integer ): TStrings;
    procedure SetSQLSection( Index: integer; Value: TStrings );
    procedure SQLSelectChange( Sender: TObject );
    procedure SQLFromChange( Sender: TObject );
    procedure SQLWhereChange( Sender: TObject );
    procedure SQLGroupChange( Sender: TObject );
    procedure SQLHavingChange( Sender: TObject );
    procedure SQLUnionChange( Sender: TObject );
    procedure SQLPlanChange( Sender: TObject );
    procedure SQLOrderChange( Sender: TObject );
    procedure SQLForUpdateChange( Sender: TObject );
    procedure SetPreventEditing( AValue: boolean ); 
    procedure SetPreventInserting( AValue: boolean );
    procedure SetPreventDeleting( AValue: boolean );
    procedure SetPreventSearching( AValue: boolean );
    function GetDataSourceCount: integer;
    function GetDataSources( Index: integer ): TIB_DataSource;
  protected
  { Inherited Property Access Methods }
    procedure SetIB_Connection( AValue: TIB_Connection ); override;
    procedure SetIB_Transaction( AValue: TIB_Transaction ); override;
    procedure SetActive( Value: boolean ); override;
    procedure SysBeforeParamsDataChange( Sender: TIB_Row;
                                         AField: TIB_Column ); override;
  { Buffering Property Access Methods }
    function GetBufferRowCount: longint; virtual;
    function GetBufferHasEOF: boolean; virtual;
    function GetBufferRowNum: longint; virtual;
    procedure SetBufferRowNum( AValue: longint ); virtual;
    function GetBufferBOF: boolean; virtual;
    function GetBufferEOF: boolean; virtual;
    function GetBufferFields: TIB_Row; virtual;
  { Property Access Methods }
    function GetCursorEOF: boolean; virtual;
    function GetCursorBOF: boolean; virtual;
    function GetEOF: boolean; virtual;
    function GetBOF: boolean; virtual;
    function GetCanModify: boolean; virtual;
    function GetCanEdit: boolean; virtual;
    function GetCanInsert: boolean; virtual;
    function GetCanDelete: boolean; virtual;
    function GetCanSearch: boolean; virtual;
    function GetNeedToPost: boolean; virtual;
    function GetState: TIB_DataSetState; virtual;
    procedure SetState( AValue: TIB_DataSetState ); virtual;
    procedure SetMasterSource( AValue: TIB_DataSource ); virtual;
    function GetMasterSource: TIB_DataSource; virtual;
    function GetRowNum: longint; virtual;
    procedure SetRowNum( AValue: longint ); virtual;
    function GetUnidirectional: boolean; virtual;
    procedure SetReadOnly( AValue: boolean ); virtual;
    function GetReadOnly: boolean; virtual;
    function GetIsRowLocked: boolean; virtual;
    procedure SetOrderingItemNo( AValue: integer ); virtual;
    procedure SetOrderingLink( AValue: string ); virtual;
    procedure SetSearchingLink( AValue: string ); virtual;
  { General methods }
    procedure ProcessTransactionEvent( AEvent: TIB_TransactionEventType );
                                                                       override;
  { Inherited Methods }
    procedure Loaded; override;
    procedure SysAfterUpdateDescriptors; override;
    procedure SysPreparedChanged; override;
    procedure SysAfterUnprepare; override;
    procedure SysExecSelect; override;
    procedure SysExecute; override;
    procedure SysClose; override;
    procedure SysBeforeFieldDataChange( Sender: TIB_Row;
                                        AField: TIB_Column); override;
    procedure SysBeforeExecuteForOutput; override;
    procedure SysAfterExecuteForOutput; override;
    procedure SysActiveChanged; override;
    procedure SysPrepareSQL; override;
    procedure SysPrepareFailed; override;
    function SysPrepare: boolean; override;
    procedure SysUnprepare; override;
    procedure SysSQLChange( Sender: TObject ); override;
  { System Methods }
    procedure SysGetCursorName; virtual;
    function SysGetCursorRowCount: longint; virtual;
    procedure CheckRequiredFields;
    procedure SysFetchSingle; virtual;
    function SysOpen: boolean; dynamic;
    function SysCount: longint; dynamic;
    procedure SysOpenAfterLoad; dynamic;
    procedure SysEdit; dynamic;
    procedure SysEditRow; dynamic;
    procedure SysInsert; dynamic;
    procedure SysInsertRow; dynamic;
    procedure SysGetDefaults; dynamic;
    procedure SysDelete; dynamic;
    procedure SysDeleteRow; dynamic;
    procedure SysPost; dynamic;
    procedure SysPostRow; dynamic;
    procedure SysPostEditedRow; dynamic;
    procedure SysPostInsertedRow; dynamic;
    procedure SysPostDeletedRow; dynamic;
    procedure SysCancel; dynamic;
    procedure SysCancelRow; dynamic;
    procedure SysCancelEditedRow; dynamic;
    procedure SysCancelInsertedRow; dynamic;
    procedure SysCancelDeletedRow; dynamic;
    procedure SysClearLock; dynamic;
    procedure SysLast; dynamic;
    procedure SysBeforeLast; dynamic;
    procedure SysLastRow; dynamic;
    procedure SysAfterLast; dynamic;
    procedure SysFirst; dynamic;
    procedure SysBeforeFirst; dynamic;
    procedure SysFirstRow; dynamic;
    procedure SysAfterFirst; dynamic;
    procedure SysMoveBy( JumpRecs: longint ); dynamic;
    procedure SysCursorMoveByRow( JumpRecs: longint ); dynamic;
    procedure SysBeforeMoveBy( JumpRecs: longint ); dynamic;
    procedure SysMoveByRow( JumpRecs: longint ); dynamic;
    procedure SysAfterMoveBy( JumpRecs: longint ); dynamic;
    procedure SysBeforeNavigate; dynamic;
    procedure SysAfternavigate; dynamic;
    procedure SysStateChanged; dynamic;
    procedure SysMasterDataChange; dynamic;
    procedure SysMasterDataUpdate; dynamic;
    procedure SysProcessCallback( Status: TIB_FetchCallbackStatus ); virtual;
  { Internal method handlers }
    procedure SysBeforeOpen; virtual;
    procedure SysAfterOpen; virtual;
    procedure SysBeforeClose; virtual;
    procedure SysAfterClose; virtual;
    procedure SysBeforeSearch; dynamic;
    procedure SysAfterSearch; dynamic;
    procedure SysBeforeEdit; dynamic;
    procedure SysAfterEdit; dynamic;
    procedure SysBeforeInsert; dynamic;
    procedure SysAfterInsert; dynamic;
    procedure SysBeforeDelete; dynamic;
    procedure SysAfterDelete; dynamic;
    procedure SysBeforePost; virtual;
    procedure SysAfterPost; virtual;
    procedure SysBeforeCancel; dynamic;
    procedure SysAfterCancel; dynamic;
  { System Cursor handling methods }
    procedure SysFetchFirst; virtual;
    procedure SysFetchAll; dynamic;
    procedure SysEditCursorRow; dynamic;
    procedure SysInsertCursorRow; dynamic;
    procedure SysDeleteCursorRow; dynamic;
    procedure SysAfterFetchCursorEOF; dynamic;
    procedure SysFetchNext; virtual;
    procedure SysAfterFetchCursorRow; virtual;
  { Master DataSet Linking Methods }
    procedure MasterPrepareSQL( Sender: TIB_DataLink;
                                DataSource: TIB_DataSource ); virtual;
    procedure MasterStateChanged( Sender: TIB_DataLink;
                                  DataSource: TIB_DataSource ); virtual;
    procedure MasterDataChange( Sender: TIB_DataLink;
                                DataSource: TIB_DataSource;
                                Field: TIB_Column ); virtual;
  { API Function Calls }
    procedure API_CreateCursor;
    function API_FetchRow: integer;
    procedure API_CloseCursor; 
  { SQL Generator procedures }
    procedure SQL_CursorUpdate;
    function SQL_CursorLock: boolean;
    procedure SQL_CursorInsert;
    procedure SQL_CursorDelete; 
  { Event Dispatch Methods }
    procedure DoBeforeOpen; dynamic;
    procedure DoAfterOpen; dynamic;
    procedure DoBeforeClose; dynamic;
    procedure DoAfterClose; dynamic;
    procedure DoBeforeSearch; dynamic;
    procedure DoAfterSearch; dynamic;
    procedure DoBeforeEdit; dynamic;
    procedure DoAfterEdit; dynamic;
    procedure DoBeforeInsert; dynamic;
    procedure DoAfterInsert; dynamic;
    procedure DoAfterDelete; dynamic;
    procedure DoBeforeDelete; dynamic;
    procedure DoBeforePost; dynamic;
    procedure DoAfterPost; dynamic;
    procedure DoBeforeCancel; dynamic;
    procedure DoAfterCancel; dynamic;
    procedure DoProcessCallback( Status: TIB_FetchCallbackStatus ); virtual;
  { Link Event Dispatch Methods }
    procedure DoLinkStateChanged;
  { Properties }
    property CursorRowNum: longint read FCursorRowNum;
    property CursorBOF: boolean read GetCursorBOF;
    property CursorEOF: boolean read GetCursorEOF;
    property SQLSelect:    TStrings Index 1 read GetSQLSection
                                            write SetSQLSection
                                            stored false;
    property SQLFrom:      TStrings Index 2 read GetSQLSection
                                            write SetSQLSection
                                            stored false;
    property SQLWhere:     TStrings Index 3 read GetSQLSection
                                            write SetSQLSection
                                            stored false;
    property SQLGroup:     TStrings Index 4 read GetSQLSection
                                            write SetSQLSection
                                            stored false;
    property SQLHaving:    TStrings Index 5 read GetSQLSection
                                            write SetSQLSection
                                            stored false;
    property SQLUnion:     TStrings Index 6 read GetSQLSection
                                            write SetSQLSection
                                            stored false;
    property SQLPlan:      TStrings Index 7 read GetSQLSection
                                            write SetSQLSection
                                            stored false;
    property SQLOrder:     TStrings Index 8 read GetSQLSection
                                            write SetSQLSection
                                            stored false;
    property SQLForUpdate: TStrings Index 9 read GetSQLSection
                                            write SetSQLSection
                                            stored false;
    property IsRowLocked: boolean read GetIsRowLocked;
    property PessimisticLocking: boolean read FPessimisticLocking
                                         write FPessimisticLocking
                                         default false;
  { Events }
    property OnFetchCallback: TIB_FetchCallbackEvent read FOnFetchCallback
                                                     write FOnFetchCallback;
    property AfterFetchRow: TIB_DataSetEvent read FAfterFetchRow
                                             write FAfterFetchRow;
    property AfterFetchEof: TIB_DataSetEvent read FAfterFetchEof
                                             write FAfterFetchEof;
    property BeforeOpen:   TIB_DataSetEvent read FBeforeOpen
                                            write FBeforeOpen;
    property AfterOpen:    TIB_DataSetEvent read FAfterOpen
                                            write FAfterOpen;
    property BeforeClose:  TIB_DataSetEvent read FBeforeClose
                                            write FBeforeClose;
    property AfterClose:   TIB_DataSetEvent read FAfterClose
                                            write FAfterClose;
    property BeforeSearch: TIB_DataSetEvent read FBeforeSearch
                                            write FBeforeSearch;
    property AfterSearch:  TIB_DataSetEvent read FAfterSearch
                                            write FAfterSearch;
    property BeforeEdit:   TIB_DataSetEvent read FBeforeEdit
                                            write FBeforeEdit;
    property AfterEdit:    TIB_DataSetEvent read FAfterEdit
                                            write FAfterEdit;
    property BeforeInsert: TIB_DataSetEvent read FBeforeInsert
                                            write FBeforeInsert;
    property AfterInsert:  TIB_DataSetEvent read FAfterInsert
                                            write FAfterInsert;
    property BeforeDelete: TIB_DataSetEvent read FBeforeDelete
                                            write FBeforeDelete;
    property AfterDelete:  TIB_DataSetEvent read FAfterDelete
                                            write FAfterDelete;
    property BeforePost:   TIB_DataSetEvent read FBeforePost
                                            write FBeforePost;
    property AfterPost:    TIB_DataSetEvent read FAfterPost
                                            write FAfterPost;
    property BeforeCancel: TIB_DataSetEvent read FBeforeCancel
                                            write FBeforeCancel;
    property AfterCancel:  TIB_DataSetEvent read FAfterCancel
                                            write FAfterCancel;
  public
  { Inherited Methods }
    constructor Create( AOwner : TComponent ); override;
    destructor Destroy; override;
    procedure Execute; override;
    procedure Unprepare; override;
    procedure InvalidateSQL; override;
  { Methods }
    procedure StateChanged; virtual;
    procedure InvalidateRows; virtual;
    procedure InvalidateRowNum( ARowNum: longint ); virtual;
    procedure SetFocus; virtual;
    procedure FetchSingle; virtual;
    procedure Open; virtual;
    procedure Close; virtual;
    procedure First; virtual;
    procedure Last; virtual;
    procedure Next; virtual;
    procedure Prior; virtual;
    procedure MoveBy( JumpRecs: longint ); virtual;
    procedure Edit; virtual;
    procedure Insert; virtual;
    procedure Delete; virtual;
    procedure Post; virtual;
    procedure Cancel; virtual;
    procedure AbortFetching; virtual;
    function Count: longint; virtual;
    procedure Search; virtual;
    procedure SaveSearch; virtual;
    procedure ClearSearch; virtual;
    procedure RecallSearch; virtual;
    procedure AddSQLWhereClause( WhereClause: string ); virtual;
    function IsLinkedTo( DataSource: TIB_DataSource ): boolean; virtual;
    procedure UpdateData; virtual;
    procedure DataChange; virtual;
    procedure GetOrderingItemsList( const OrderingItemsList: TStrings );
    function GetOrderingSQL( ItemNo: integer ): string;
    procedure DefaultProcessCallback( Status: TIB_FetchCallbackStatus );
  { Abstract Buffering Properties }
    property BufferFields: TIB_Row read GetBufferFields;
    property BufferRowNum: longint read GetBufferRowNum write SetBufferRowNum;
    property BufferEOF: boolean read GetBufferEOF;
    property BufferBOF: boolean read GetBufferBOF;
    property BufferRowCount: longint read GetBufferRowCount;
    property BufferHasEOF: boolean read GetBufferHasEOF;
  { Properties }
    property DataSourceCount: integer read GetDataSourceCount;
    property DataSources[ Index: integer ]: TIB_DataSource
        read GetDataSources;
    property State: TIB_DataSetState read GetState;
    property Unidirectional: boolean read GetUnidirectional;
    property EOF: boolean read GetEOF;
    property BOF: boolean read GetBOF;
    property RowNum: longint read GetRowNum write SetRowNum;
    property CanModify: boolean read GetCanModify;
    property CanEdit: boolean read GetCanEdit;
    property CanInsert: boolean read GetCanInsert;
    property CanDelete: boolean read GetCanDelete;
    property CanSearch: boolean read GetCanSearch;
    property ClosePending: boolean read FClosePending;
    property NeedToPost: boolean read GetNeedToPost;
    property IsPosting: boolean read FIsPosting;
    property ReadOnly: boolean read GetReadOnly write SetReadOnly default false;
    property PreventEditing: boolean read FPreventEditing
                                     write SetPreventEditing
                                     default false;
    property PreventInserting: boolean read FPreventInserting
                                       write SetPreventInserting
                                       default false;
    property PreventDeleting: boolean read FPreventDeleting
                                      write SetPreventDeleting
                                      default false;
    property PreventSearching: boolean read FPreventSearching
                                       write SetPreventSearching
                                       default false;
    property AutoFetchFirst: boolean read FAutoFetchFirst
                                     write FAutoFetchFirst
                                     default true;
    property Fetching: boolean read FFetching;
    property FetchCallbackInc: cardinal read FFetchCallbackInc
                                        write FFetchCallbackInc
                                        default 256;
    property FetchAborted: boolean read FFetchAborted;
    property HintInsert: string read GetHintInsert write SetHintInsert;
    property HintEdit:   string read GetHintEdit   write SetHintEdit;
    property HintDelete: string read GetHintDelete write SetHintDelete;
    property HintPost:   string read GetHintPost   write SetHintPost;
    property HintCancel: string read GetHintCancel write SetHintCancel;
    property HintFirst:  string read GetHintFirst  write SetHintFirst;
    property HintLast:   string read GetHintLast   write SetHintLast;
    property HintNext:   string read GetHintNext   write SetHintNext;
    property HintPrior:  string read GetHintPrior  write SetHintPrior;
    property HintSearch: string read GetHintSearch write SetHintSearch;
    property HintCount:  string read GetHintCount  write SetHintCount;
    property HintOrder:  string read GetHintOrder  write SetHintOrder;
    property MasterDataSet: TIB_DataSet read GetMasterDataSet;
    property MasterLinkCount: integer read GetMasterLinkCount;
    property MasterLink[ Index: string ]: string read GetMasterLink
                                                 write SetMasterLink;
    property DetailLink[ Index: integer ]: string read GetDetailLink
                                                  write SetDetailLink;
    property MasterRelation [ Index: integer ]: string read GetMasterRelation;
    property MasterFieldName[ Index: integer ]: string read GetMasterFieldName;
    property DetailRelation [ Index: integer ]: string read GetDetailRelation;
    property DetailFieldName[ Index: integer ]: string read GetDetailFieldName;
    property SQLWhereChanged: boolean read FSQLWhereChanged;
    property SQLOrderChanged: boolean read FSQLOrderChanged;
    property SQLWhereLow: TStrings read FSQLWhereLow;
    property SQLWhereMed: TStrings read FSQLWhereMed;
    property SQLWhereHigh: TStrings read FSQLWhereHigh;
    property SQLWhereParams: TStrings read FSQLWhereParams;
    property OrderingField: TIB_Column read FOrderingField;
    property SearchingParam: TIB_Column read FSearchingParam;
    property SearchingParamName: string read FSearchingParamName;
    property SettingOrderingLink: boolean read FSettingOrderingLink;
    property SettingSearchingLink: boolean read FSettingSearchingLink;
published
    property ColorScheme: boolean read FColorScheme
                                  write FColorScheme
                                  default false;
    property FieldsAlignment;
    property FieldsDisplayFormat;
    property FieldsDisplayLabel;
    property FieldsDisplayWidth;
    property FieldsEditMask;
    property FieldsIndex;
    property FieldsVisible;
    property GeneratorLinks: TStrings read GetGeneratorLinks
                                      write SetGeneratorLinks;
    property GetDefaults: boolean read FGetDefaults
                                  write FGetDefaults
                                  default false;
    property Hints;
    property MasterSource: TIB_DataSource read GetMasterSource
                                          write SetMasterSource;
    property MasterLinks: TStrings read FMasterLinks write SetMasterLinks;
    property MasterSearch: boolean read FMasterSearch
                                   write FMasterSearch
                                   default false;
    property OrderingItems: TStrings read FOrderingItems
                                     write SetOrderingItems;
    property OrderingLinks: TStrings read FOrderingLinks
                                     write SetOrderingLinks;
    property OrderingItemNo: integer read FOrderingItemNo
                                     write SetOrderingItemNo
                                     default 0;
    property OrderingLink: string read FOrderingLink
                                  write SetOrderingLink;
    property SearchingLinks: TStrings read FSearchingLinks
                                      write SetSearchingLinks;
    property SearchingLink: string read FSearchingLink
                                   write SetSearchingLink;
    property SQLKeyFields: TStrings read FSQLKeyFields write SetSQLKeyFields;
    property SQLJoinLinks: TStrings read FSQLJoinLinks write SetSQLJoinLinks;
    property SQLKeyRelation;
    {------------------------------------------------------------------------------}
    property _DataSourceCount: integer read GetDataSourceCount
                                       write flag_junk_value
                                       stored false;
  end;

{                                                                              }
{ TIB_Cursor                                                                   }
{                                                                              }

  TIB_Cursor = class( TIB_DataSet )
  public
    property IsRowLocked;  
    property SQLSelect;
    property SQLFrom;
    property SQLWhere;
    property SQLGroup;
    property SQLHaving;
    property SQLUnion;
    property SQLPlan;
    property SQLOrder;
    property SQLForUpdate;
  published
    property Active;
    property Prepared;
    property ReadOnly;
    property PessimisticLocking;
    property PreventEditing;
    property PreventInserting;
    property PreventDeleting;
    property PreventSearching;
    property FetchCallbackInc;
    property AfterFetchRow;
    property AfterFetchEof;
    property OnActiveChanged;
    property OnPreparedChanged;
    property OnFetchCallback; 
    property BeforePrepare;
    property AfterPrepare;
    property BeforeUnprepare;
    property AfterUnprepare;
    property BeforeOpen;
    property AfterOpen;
    property BeforeClose;
    property AfterClose;
    property BeforeEdit;
    property AfterEdit;
    property BeforeSearch;
    property AfterSearch;
    property BeforeInsert;
    property AfterInsert;
    property BeforeDelete;
    property AfterDelete;
    property BeforePost;
    property AfterPost;
    property BeforeCancel;
    property AfterCancel;
  end;  { TIB_Cursor }
  
// IMP_IB_DATASET
