
{                                                                              }
{ TIB_DataSource                                                               }
{                                                                              }

  TIB_DataChangeEvent = procedure( Sender: TIB_DataSource;
                                   ADataSet: TIB_DataSet;
                                   AField: TIB_Column) of object;

  TIB_DataSourceEvent = procedure( Sender: TIB_DataSource;
                                   ADataSet: TIB_DataSet ) of object;

  TIB_DataSource = class(TIB_StatementLink)
  private
  { Utility Storage Fields }
    FIB_DataLinkList: TList;
  { Property Storage Fields }
    FAutoEdit: boolean;
    FAutoInsert: boolean;
    FAnnounceFocus: boolean;
    FAllowFocus: boolean;
    FEnabled: boolean;
  { Flag for testing }
    flag_junk_value: integer;
  { Event Storage Fields }
    FBeforeAssignment: TIB_DataSourceEvent;
    FAfterAssignment: TIB_DataSourceEvent;
    FOnGainFocus: TIB_DataSourceEvent;
    FOnLoseFocus: TIB_DataSourceEvent;
    FOnStateChanged: TIB_DataSourceEvent;
    FOnDataChange: TIB_ColLinkEvent;
    FOnUpdateData: TIB_ColLinkEvent;
  { Inhertied }
    procedure SetStatement( AValue: TIB_Statement ); override;
  { Property Access Methods }
    function GetDataLinkCount: integer;
    function GetDataSet: TIB_DataSet; virtual;
    procedure SetDataSet( AValue: TIB_DataSet ); virtual;
    function GetState: TIB_DataSetState; virtual;
    function GetRowState: TIB_RowState; virtual;
    function GetReadOnly: boolean; virtual;
    function GetCanModify: boolean; virtual;
    procedure SetEnabled( AValue: boolean ); virtual;
    function GetNeedToPost: boolean; virtual;
    function GetEOF: boolean;
    function GetBOF: boolean;
    procedure SetAnnounceFocus( AValue: boolean );
    procedure SetAllowFocus( AValue: boolean );
    function IsAllowFocusStored: boolean;
  protected
  { Inherited Methods }
    procedure SysPrepareSQL; override;
    procedure SysBeforeUpdateDescriptors; override;
    procedure SysAfterUpdateDescriptors; override;
    procedure ProcessEvent( AEvent: TIB_StatementEventType;
                            Info: longint ); override;
  { System Methods }
    procedure SysStateChanged; virtual;
  { Event Dispatch Methods  }
    procedure DoGainFocus; virtual;
    procedure DoLoseFocus; virtual;
    procedure DoStateChanged; virtual;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  { Utility Methods }
    procedure AddDataLink( ADataLink: TObject ); virtual;
    procedure RemoveDataLink( ADataLink: TObject ); virtual;
  { Methods }
    function IsLinkedTo(DataSet: TIB_DataSet): boolean;
    function Edit: boolean; dynamic;
    function Insert: boolean; dynamic;
    function Modify: boolean; dynamic;
    function Modifying: boolean; dynamic;
    procedure Reset; dynamic;
    procedure SetFocus; dynamic;
  { Properties }
    property DataLinkCount: integer read GetDatalinkCount;
    property State: TIB_DataSetState read GetState;
    property RowState: TIB_RowState read GetRowState;
    property StatementType: TIB_StatementType read GetStatementType;
    property ReadOnly: boolean read GetReadOnly;
    property CanModify: boolean read GetCanModify;
    property NeedToPost: boolean read GetNeedToPost;
    property EOF: boolean read GetEOF;
    property BOF: boolean read GetBOF;
  published
  { Properties }
    property AnnounceFocus: boolean read FAnnounceFocus
                                    write SetAnnounceFocus
                                    default false;
    property AllowFocus: boolean read FAllowFocus
                                 write SetAllowFocus
                                 stored IsAllowFocusStored;
    property AutoEdit: boolean read FAutoEdit
                               write FAutoEdit
                               default true;
    property AutoInsert: boolean read FAutoInsert
                                 write FAutoInsert
                                 default true;
    property DataSet: TIB_DataSet read GetDataSet write SetDataSet;
    property Enabled: boolean read FEnabled write SetEnabled default true;
{------------------------------------------------------------------------------}
    property _DataLinkCount: integer read GetDatalinkCount
                                     write flag_junk_value
                                     stored false;
{------------------------------------------------------------------------------}
  { Events }
    property BeforeAssignment: TIB_DataSourceEvent read FBeforeAssignment
                                                   write FBeforeAssignment;
    property AfterAssignment: TIB_DataSourceEvent read FAfterAssignment
                                                  write FAfterAssignment;
    property OnGainFocus: TIB_DataSourceEvent read FOnGainFocus
                                              write FOnGainFocus;
    property OnLoseFocus: TIB_DataSourceEvent read FOnLoseFocus
                                              write FOnLoseFocus;
    property OnDataChange: TIB_ColLinkEvent read FOnDataChange
                                            write FOnDataChange;
    property OnUpdateData: TIB_ColLinkEvent read FOnUpdateData
                                            write FOnUpdateData;
    property OnStateChanged: TIB_DataSourceEvent read FOnStateChanged
                                                 write FOnStateChanged;
  end; { TIB_DataSource }

// IMP_IB_DataSource
