
{                                                                              }
{ TIB_Database                                                                 }
{                                                                              }

  TIB_Database = class(TIB_Connection)
  private
    FIB_Transaction: TIB_TransactionSingle;
    flag_junk_value: integer;
  protected
    procedure SetName( const NewName: TComponentName ); override;
    procedure SetAnnounceFocus( AValue: boolean ); override;
    function GetPtrHandle: pisc_tr_handle;
    function GetTransactionState: TIB_TransactionState;
    function GetPostPendingCount: integer;
    function GetStarted: boolean;
    procedure SetStarted( AValue: boolean );
    function GetAutoCommit: boolean;
    procedure SetAutoCommit( AValue: boolean );
    function GetAutoStart: boolean;
    procedure SetAutoStart( AValue: boolean );
    function GetAutoStartPending: boolean;
    function GetDDL_PostAll: boolean;
    procedure SetDDL_PostAll( AValue: boolean );
    function GetDDL_Commit: boolean;
    procedure SetDDL_Commit( AValue: boolean );
    function GetReadOnly: boolean;
    procedure SetReadOnly( AValue: boolean );
    function GetIsolation: TIB_Isolation;
    procedure SetIsolation( AValue: TIB_Isolation );
    function GetRecVersion: boolean;
    procedure SetRecVersion( AValue: boolean );
    function GetLockWait: boolean;
    procedure SetLockWait( AValue: boolean );
    function GetBeforeStart: TIB_TransactionEvent;
    procedure SetBeforeStart( AValue: TIB_TransactionEvent );
    function GetAfterStart: TIB_TransactionEvent;
    procedure SetAfterStart( AValue: TIB_TransactionEvent );
    function GetBeforeCommit: TIB_TransactionEvent;
    procedure SetBeforeCommit( AValue: TIB_TransactionEvent );
    function GetAfterCommit: TIB_TransactionEvent;
    procedure SetAfterCommit( AValue: TIB_TransactionEvent );
    function GetBeforeSavePoint: TIB_TransactionEvent;
    procedure SetBeforeSavePoint( AValue: TIB_TransactionEvent );
    function GetAfterSavePoint: TIB_TransactionEvent;
    procedure SetAfterSavePoint( AValue: TIB_TransactionEvent );
    function GetBeforeRollback: TIB_TransactionEvent;
    procedure SetBeforeRollback( AValue: TIB_TransactionEvent );
    function GetAfterRollback: TIB_TransactionEvent;
    procedure SetAfterRollback( AValue: TIB_TransactionEvent );
    function GetBeforeEnd: TIB_TransactionEvent;
    procedure SetBeforeEnd( AValue: TIB_TransactionEvent );
    function GetAfterEnd: TIB_TransactionEvent;
    procedure SetAfterEnd( AValue: TIB_TransactionEvent );
    function GetTransactionLinkCount: integer;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  { Methods from IB_Transaction }
    procedure StartTransaction;
    procedure Start; dynamic;
    procedure Activate; dynamic;
    procedure SavePoint; dynamic;
    procedure Commit; dynamic;
    procedure Rollback; dynamic;
    function CloseWithConfirm: TModalResult; dynamic;
    procedure PostAll; dynamic;
    procedure CancelAll; dynamic;
    procedure UpdateStatus; dynamic;
    procedure SetFocus; override;
  { Properties }
    property IB_Transaction: TIB_TransactionSingle read FIB_Transaction;
    property PtrHandle: pisc_tr_handle read GetPtrHandle;
    property TransactionState: TIB_TransactionState read GetTransactionState;
    property PostPendingCount: integer read GetPostPendingCount;
  published
  { Properties }
    property Started: boolean read GetStarted
                              write SetStarted
                              default false;
    property AutoCommit: boolean read GetAutoCommit
                                 write SetAutoCommit
                                 default true;
    property AutoStart: boolean read GetAutoStart
                                write SetAutoStart
                                default false;
    property AutoStartPending: boolean read GetAutoStartPending;
    property DDL_PostAll: boolean read GetDDL_PostAll
                                  write SetDDL_PostAll
                                  default false;
    property DDL_Commit: boolean read GetDDL_Commit
                                 write SetDDL_Commit
                                 default false;
    property ReadOnly: boolean read GetReadOnly
                               write SetReadOnly
                               default false;
    property Isolation: TIB_Isolation read GetIsolation
                                      write SetIsolation
                                      default tiConcurrency;
    property RecVersion: boolean read GetRecVersion
                                 write SetRecVersion
                                 default false;
    property LockWait: boolean read GetLockWait
                               write SetLockWait
                               default true;
    property BeforeStart:     TIB_TransactionEvent read GetBeforeStart
                                                   write SetBeforeStart;
    property AfterStart:      TIB_TransactionEvent read GetAfterStart
                                                   write SetAfterStart;
    property BeforeCommit:    TIB_TransactionEvent read GetBeforeCommit
                                                   write SetBeforeCommit;
    property AfterCommit:     TIB_TransactionEvent read GetAfterCommit
                                                   write SetAfterCommit;
    property BeforeSavePoint: TIB_TransactionEvent read GetBeforeSavePoint
                                                   write SetBeforeSavePoint;
    property AfterSavePoint:  TIB_TransactionEvent read GetAfterSavePoint
                                                   write SetAfterSavePoint;
    property BeforeRollback:  TIB_TransactionEvent read GetBeforeRollback
                                                   write SetBeforeRollback;
    property AfterRollback:   TIB_TransactionEvent read GetAfterRollback
                                                   write SetAfterRollback;
    property BeforeEnd:       TIB_TransactionEvent read GetBeforeEnd
                                                   write SetBeforeEnd;
    property AfterEnd:        TIB_TransactionEvent read GetAfterEnd
                                                   write SetAfterEnd;
{------------------------------------------------------------------------------}
    property _TransactionLinkCount: integer read GetTransactionLinkCount
                                            write flag_junk_value
                                            stored false;

  end;

