
{                                                                              }
{ TIB_Row                                                                      }
{                                                                              }

  TIB_RowEvent = procedure( ARow: TIB_Row ) of object;
  TIB_RowChangedEvent = procedure( ARow: TIB_Row;
                                   AField: TIB_Column) of object;

  TIB_Row = class(TObject)
  private
  { Property Stroage fields }
    FStatement: TIB_Statement;
    FBlobList: TList;
    FArrayList: TList;
    FColumnList: TList;
    FColumnCount: smallint;
    FPSQLDA: PXSQLDA;
    FRowType: TIB_RowType;
    FRowState: TIB_RowState;
    FVarsCreated: boolean;
    FCursorName: string;
  { Record buffer storage Columns }
    FBufferLength: integer;
    FRowBuffer: pointer;
    FOldBuffer: pointer;
  { Info property storage Columns }
    FFocusedRelationNo: integer;
    FRelationList: TStringList;
  { Event storage Columns }
    FBeforeModify: TIB_RowChangedEvent;
    FAfterModify: TIB_RowChangedEvent;
    FOnRowStateChanged: TIB_RowEvent;
  protected
  { Property Access Methods }
    function GetColumnCount: smallint;
    function GetColumns( Index: smallint ): TIB_Column;
    function GetRelationCount: integer;
    function GetRelationName( Index: integer ): string;
    function GetFocusedRelationNo: integer;
    function GetFocusedRelationName: string;
    procedure SetFocusedRelationNo( AValue: integer );
    procedure SetFocusedRelationName( AValue: string );
    procedure SetRowState( AValue: TIB_RowState );
  { Utility Methods }
    procedure CreateVARList;
    procedure FreeVARList;
    procedure DefaultColumnCreation(     NewIndex: smallint;
                                     var NewIB_Column: TIB_Column );
  { System Methods }
    procedure SysClearBuffer( Buffer: pointer );
    procedure SysRowStateChanged;
    procedure SysBeforeColumnModify( IB_Field: TIB_Column );
    procedure SysAfterColumnModify( IB_Field: TIB_Column );
    procedure SysBeforeModify( IB_Field: TIB_Column );
    procedure SysAfterModify( IB_Field: TIB_Column );
  { Event Dispatch Methods }
    procedure DoBeforeModify( IB_Field: TIB_Column );
    procedure DoAfterModify( IB_Field: TIB_Column );
  { System Methods }
    procedure SysUpdate( NewColumnCount: smallint );
    procedure SysClose;
  { System Properties }
    property CursorName: string read FCursorname;
  public
    constructor Create( AStatement: TIB_Statement;
                        DescType: TIB_RowType );
    destructor Destroy; override;
  { Utility Methods }
    procedure ClearBuffers( NewRowState: TIB_RowState );
    procedure PostBuffers;
    procedure CancelBuffers;
    procedure RefreshBuffers( NewRecord: boolean );
//    procedure MergeBuffers;
    procedure UpdateBufferPointers;
  { Column access methods }
    function GetByName(     AFieldName: string;
                        var AIB_Field: TIB_Column ): boolean;
    function GetByFieldNo(     AFieldNo: smallint;
                           var AIB_Field: TIB_Column ): boolean;
    function ByName( AFieldName: string ): TIB_Column;
    function ByFieldNo( AFieldNo: smallint ): TIB_Column;
  { Properties }
    property Statement: TIB_Statement read FStatement;
    property RowType: TIB_RowType read FRowType;
    property RowState: TIB_RowState read FRowState;
    property PSQLDA: PXSQLDA read FPSQLDA;
    property ColumnCount: smallint read GetColumnCount;
    property Columns[ Index: smallint ]: TIB_Column read GetColumns; default;
    property BufferLength: integer read FBufferLength;
    property OldBuffer: pointer read FOldBuffer write FOldBuffer;
    property RowBuffer: pointer read FRowBuffer write FRowBuffer;
    property RelationCount: integer read GetRelationCount;
    property RelationNames[ Index: integer ]: string read GetRelationName;
    property FocusedRelationNo: integer read GetFocusedRelationNo
                                        write SetFocusedRelationNo;
    property FocusedRelationName: string read GetFocusedRelationName
                                         write SetFocusedRelationName;
  { Events }
    property BeforeModify: TIB_RowChangedEvent read FBeforeModify
                                               write FBeforeModify;
    property AfterModify: TIB_RowChangedEvent read FAfterModify
                                              write FAfterModify;
    property OnRowStateChanged: TIB_RowEvent read FOnRowStateChanged
                                             write FOnRowStateChanged;
  end;

// IMP_IB_Row
