
{                                                                              }
{ TIB_StatementLink                                                            }
{                                                                              }

  TIB_StmtLinkEvent = procedure ( Sender: TIB_StatementLink;
                                  Statement: TIB_Statement ) of object;

  TIB_ColLinkEvent = procedure ( Sender: TIB_StatementLink;
                                 Statement: TIB_Statement;
                                 Field: TIB_Column ) of object;

  TIB_StatementLink = class(TIB_Component)
  private
  { Property Storage Fields }
    FStatement: TIB_Statement;
  { Event storage }
    FOnPrepareSQL: TIB_StmtLinkEvent;
  { Property access methods }
    function GetPrepared: boolean;
    function GetActive: boolean;
    function GetStatementType: TIB_StatementType;
  protected
  { Property Access Methods }
    procedure SetStatement( AValue: TIB_Statement ); virtual;
  { System methods }
    procedure SysPrepareSQL; virtual;
    procedure SysBeforeUpdateDescriptors; virtual;
    procedure SysAfterUpdateDescriptors; virtual;
  { Methods }
    procedure ProcessEvent( AEvent: TIB_StatementEventType;
                            Info: longint ); virtual;
  public
  { Inherited Methods }
    destructor Destroy; override;
  { Properties }
    property Prepared: boolean read GetPrepared;
    property Active: boolean read GetActive;
    property StatementType: TIB_StatementType read GetStatementType;
    property Statement: TIB_Statement read FStatement
                                      write SetStatement;
  published
    property OnPrepareSQL: TIB_StmtLinkEvent read FOnPrepareSQL
                                             write FOnPrepareSQL;
  end; { TIB_StatementLink }

// IMP_IB_StatementLink
