
{                                                                              }
{ TIB_TransactionLink                                                          }
{                                                                              }

  TIB_TransactionLinkEvent = procedure( Sender: TIB_TransactionLink;
                                       ATransaction: TIB_Transaction) of object;

  TIB_TransactionLink = class(TIB_Component)
  private
  { Property Storage Fields }
    FIB_Transaction: TIB_Transaction;
    FReceiveFocus: boolean;
  { Event Storage }
    FOnReceiveFocus: TIB_TransactionLinkEvent;
  protected
  { Property Access Methods }
    function GetStarted: boolean; virtual;
    function GetTransactionState: TIB_TransactionState; virtual;
    procedure SetIB_Transaction( AValue: TIB_Transaction ); virtual;
    procedure SetReceiveFocus( AValue: boolean ); virtual;
  { Inherited Methods }
    procedure Loaded; override;
  public
  { Inherited Methods }
    constructor Create( AOwner: TComponent ); override;
    destructor Destroy; override;
  { Event Dispatch Methods }
    procedure DoReceiveFocus( T: TIB_Transaction ); virtual;
    procedure ProcessEvent( AEvent: TIB_TransactionEventType ); virtual;
  { Properties }
    property TransactionState: TIB_TransactionState read GetTransactionState;
    property Started: boolean read GetStarted;
  published
  { Properties }
    property IB_Transaction: TIB_Transaction read FIB_Transaction
                                             write SetIB_Transaction;
    property ReceiveFocus: boolean read FReceiveFocus write SetReceiveFocus;
  { Events }
    property OnReceiveFocus: TIB_TransactionLinkEvent read FOnReceiveFocus
                                                      write FOnReceiveFocus;
  end;

  TIB_TransactionStatementLink = class( TIB_TransactionLink )
  private
    FStatement: TIB_Statement;
  public
    procedure ProcessEvent( AEvent: TIB_TransactionEventType ); override;
  end;

// IMP_IB_TransactionLink
