unit Main;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, HookUnit;

type
  THookForm = class(TForm)
    SysHookBtn: TButton;
    RemoveHookBtn: TButton;
    TaskHookBtn: TButton;
    procedure FormCreate(Sender: TObject);
    procedure SysHookBtnClick(Sender: TObject);
    procedure RemoveHookBtnClick(Sender: TObject);
    procedure TaskHookBtnClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  public
    procedure UpdateButtons;
  end;

var
  HookForm: THookForm;

implementation

{$R *.DFM}

procedure THookForm.FormCreate(Sender: TObject);
begin
  UpdateButtons;
end;

procedure THookForm.FormDestroy(Sender: TObject);
begin
  while IsHookSet do
    RemoveHook; { Make sure we unhook ourselves. }
end;

procedure THookForm.SysHookBtnClick(Sender: TObject);
begin
  if not InstallSystemHook then
    ShowMessage('Could not install mouse hook.  SetWindowsHookEx() failed.');
  UpdateButtons;
end;

procedure THookForm.TaskHookBtnClick(Sender: TObject);
begin
  if not InstallTaskHook then
    ShowMessage('Could not install task hook.  SetWindowsHookEx() failed.');
  UpdateButtons;
end;

procedure THookForm.RemoveHookBtnClick(Sender: TObject);
begin
  if IsHookSet then
    RemoveHook;
  UpdateButtons;
end;

procedure THookForm.UpdateButtons;
begin
  SysHookBtn.Enabled := not IsHookSet;
  TaskHookBtn.Enabled := not IsHookSet;
  RemoveHookBtn.Enabled := IsHookSet;
end;

end.

